<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/tensorboard_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [TensorboardService.CreateTensorboardExperiment][google.cloud.aiplatform.v1.TensorboardService.CreateTensorboardExperiment].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.CreateTensorboardExperimentRequest</code>
 */
class CreateTensorboardExperimentRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the Tensorboard to create the
     * TensorboardExperiment in. Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * The TensorboardExperiment to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.TensorboardExperiment tensorboard_experiment = 2;</code>
     */
    private $tensorboard_experiment = null;
    /**
     * Required. The ID to use for the Tensorboard experiment, which becomes the
     * final component of the Tensorboard experiment's resource name.
     * This value should be 1-128 characters, and valid characters
     * are /[a-z][0-9]-/.
     *
     * Generated from protobuf field <code>string tensorboard_experiment_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $tensorboard_experiment_id = '';

    /**
     * @param string                                            $parent                  Required. The resource name of the Tensorboard to create the
     *                                                                                   TensorboardExperiment in. Format:
     *                                                                                   `projects/{project}/locations/{location}/tensorboards/{tensorboard}`
     *                                                                                   Please see {@see TensorboardServiceClient::tensorboardExperimentName()} for help formatting this field.
     * @param \Google\Cloud\AIPlatform\V1\TensorboardExperiment $tensorboardExperiment   The TensorboardExperiment to create.
     * @param string                                            $tensorboardExperimentId Required. The ID to use for the Tensorboard experiment, which becomes the
     *                                                                                   final component of the Tensorboard experiment's resource name.
     *
     *                                                                                   This value should be 1-128 characters, and valid characters
     *                                                                                   are /[a-z][0-9]-/.
     *
     * @return \Google\Cloud\AIPlatform\V1\CreateTensorboardExperimentRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\AIPlatform\V1\TensorboardExperiment $tensorboardExperiment, string $tensorboardExperimentId): self
    {
        return (new self())
            ->setParent($parent)
            ->setTensorboardExperiment($tensorboardExperiment)
            ->setTensorboardExperimentId($tensorboardExperimentId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the Tensorboard to create the
     *           TensorboardExperiment in. Format:
     *           `projects/{project}/locations/{location}/tensorboards/{tensorboard}`
     *     @type \Google\Cloud\AIPlatform\V1\TensorboardExperiment $tensorboard_experiment
     *           The TensorboardExperiment to create.
     *     @type string $tensorboard_experiment_id
     *           Required. The ID to use for the Tensorboard experiment, which becomes the
     *           final component of the Tensorboard experiment's resource name.
     *           This value should be 1-128 characters, and valid characters
     *           are /[a-z][0-9]-/.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\TensorboardService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the Tensorboard to create the
     * TensorboardExperiment in. Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the Tensorboard to create the
     * TensorboardExperiment in. Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The TensorboardExperiment to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.TensorboardExperiment tensorboard_experiment = 2;</code>
     * @return \Google\Cloud\AIPlatform\V1\TensorboardExperiment|null
     */
    public function getTensorboardExperiment()
    {
        return $this->tensorboard_experiment;
    }

    public function hasTensorboardExperiment()
    {
        return isset($this->tensorboard_experiment);
    }

    public function clearTensorboardExperiment()
    {
        unset($this->tensorboard_experiment);
    }

    /**
     * The TensorboardExperiment to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.TensorboardExperiment tensorboard_experiment = 2;</code>
     * @param \Google\Cloud\AIPlatform\V1\TensorboardExperiment $var
     * @return $this
     */
    public function setTensorboardExperiment($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\TensorboardExperiment::class);
        $this->tensorboard_experiment = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the Tensorboard experiment, which becomes the
     * final component of the Tensorboard experiment's resource name.
     * This value should be 1-128 characters, and valid characters
     * are /[a-z][0-9]-/.
     *
     * Generated from protobuf field <code>string tensorboard_experiment_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getTensorboardExperimentId()
    {
        return $this->tensorboard_experiment_id;
    }

    /**
     * Required. The ID to use for the Tensorboard experiment, which becomes the
     * final component of the Tensorboard experiment's resource name.
     * This value should be 1-128 characters, and valid characters
     * are /[a-z][0-9]-/.
     *
     * Generated from protobuf field <code>string tensorboard_experiment_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setTensorboardExperimentId($var)
    {
        GPBUtil::checkString($var, True);
        $this->tensorboard_experiment_id = $var;

        return $this;
    }

}

