<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/migration_service.proto

namespace Google\Cloud\AIPlatform\V1\MigrateResourceRequest;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Config for migrating Dataset in datalabeling.googleapis.com to Vertex
 * AI's Dataset.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.MigrateResourceRequest.MigrateDataLabelingDatasetConfig</code>
 */
class MigrateDataLabelingDatasetConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Full resource name of data labeling Dataset.
     * Format:
     * `projects/{project}/datasets/{dataset}`.
     *
     * Generated from protobuf field <code>string dataset = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $dataset = '';
    /**
     * Optional. Display name of the Dataset in Vertex AI.
     * System will pick a display name if unspecified.
     *
     * Generated from protobuf field <code>string dataset_display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $dataset_display_name = '';
    /**
     * Optional. Configs for migrating AnnotatedDataset in
     * datalabeling.googleapis.com to Vertex AI's SavedQuery. The specified
     * AnnotatedDatasets have to belong to the datalabeling Dataset.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.MigrateResourceRequest.MigrateDataLabelingDatasetConfig.MigrateDataLabelingAnnotatedDatasetConfig migrate_data_labeling_annotated_dataset_configs = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $migrate_data_labeling_annotated_dataset_configs;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $dataset
     *           Required. Full resource name of data labeling Dataset.
     *           Format:
     *           `projects/{project}/datasets/{dataset}`.
     *     @type string $dataset_display_name
     *           Optional. Display name of the Dataset in Vertex AI.
     *           System will pick a display name if unspecified.
     *     @type array<\Google\Cloud\AIPlatform\V1\MigrateResourceRequest\MigrateDataLabelingDatasetConfig\MigrateDataLabelingAnnotatedDatasetConfig>|\Google\Protobuf\Internal\RepeatedField $migrate_data_labeling_annotated_dataset_configs
     *           Optional. Configs for migrating AnnotatedDataset in
     *           datalabeling.googleapis.com to Vertex AI's SavedQuery. The specified
     *           AnnotatedDatasets have to belong to the datalabeling Dataset.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\MigrationService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Full resource name of data labeling Dataset.
     * Format:
     * `projects/{project}/datasets/{dataset}`.
     *
     * Generated from protobuf field <code>string dataset = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getDataset()
    {
        return $this->dataset;
    }

    /**
     * Required. Full resource name of data labeling Dataset.
     * Format:
     * `projects/{project}/datasets/{dataset}`.
     *
     * Generated from protobuf field <code>string dataset = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setDataset($var)
    {
        GPBUtil::checkString($var, True);
        $this->dataset = $var;

        return $this;
    }

    /**
     * Optional. Display name of the Dataset in Vertex AI.
     * System will pick a display name if unspecified.
     *
     * Generated from protobuf field <code>string dataset_display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDatasetDisplayName()
    {
        return $this->dataset_display_name;
    }

    /**
     * Optional. Display name of the Dataset in Vertex AI.
     * System will pick a display name if unspecified.
     *
     * Generated from protobuf field <code>string dataset_display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDatasetDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->dataset_display_name = $var;

        return $this;
    }

    /**
     * Optional. Configs for migrating AnnotatedDataset in
     * datalabeling.googleapis.com to Vertex AI's SavedQuery. The specified
     * AnnotatedDatasets have to belong to the datalabeling Dataset.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.MigrateResourceRequest.MigrateDataLabelingDatasetConfig.MigrateDataLabelingAnnotatedDatasetConfig migrate_data_labeling_annotated_dataset_configs = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getMigrateDataLabelingAnnotatedDatasetConfigs()
    {
        return $this->migrate_data_labeling_annotated_dataset_configs;
    }

    /**
     * Optional. Configs for migrating AnnotatedDataset in
     * datalabeling.googleapis.com to Vertex AI's SavedQuery. The specified
     * AnnotatedDatasets have to belong to the datalabeling Dataset.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.MigrateResourceRequest.MigrateDataLabelingDatasetConfig.MigrateDataLabelingAnnotatedDatasetConfig migrate_data_labeling_annotated_dataset_configs = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Cloud\AIPlatform\V1\MigrateResourceRequest\MigrateDataLabelingDatasetConfig\MigrateDataLabelingAnnotatedDatasetConfig>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setMigrateDataLabelingAnnotatedDatasetConfigs($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\AIPlatform\V1\MigrateResourceRequest\MigrateDataLabelingDatasetConfig\MigrateDataLabelingAnnotatedDatasetConfig::class);
        $this->migrate_data_labeling_annotated_dataset_configs = $arr;

        return $this;
    }

}


