<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/migration_service.proto

namespace Google\Cloud\AIPlatform\V1\MigrateResourceRequest;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Config for migrating version in ml.googleapis.com to Vertex AI's Model.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.MigrateResourceRequest.MigrateMlEngineModelVersionConfig</code>
 */
class MigrateMlEngineModelVersionConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The ml.googleapis.com endpoint that this model version should
     * be migrated from. Example values:
     * * ml.googleapis.com
     * * us-centrall-ml.googleapis.com
     * * europe-west4-ml.googleapis.com
     * * asia-east1-ml.googleapis.com
     *
     * Generated from protobuf field <code>string endpoint = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $endpoint = '';
    /**
     * Required. Full resource name of ml engine model version.
     * Format: `projects/{project}/models/{model}/versions/{version}`.
     *
     * Generated from protobuf field <code>string model_version = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $model_version = '';
    /**
     * Required. Display name of the model in Vertex AI.
     * System will pick a display name if unspecified.
     *
     * Generated from protobuf field <code>string model_display_name = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $model_display_name = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $endpoint
     *           Required. The ml.googleapis.com endpoint that this model version should
     *           be migrated from. Example values:
     *           * ml.googleapis.com
     *           * us-centrall-ml.googleapis.com
     *           * europe-west4-ml.googleapis.com
     *           * asia-east1-ml.googleapis.com
     *     @type string $model_version
     *           Required. Full resource name of ml engine model version.
     *           Format: `projects/{project}/models/{model}/versions/{version}`.
     *     @type string $model_display_name
     *           Required. Display name of the model in Vertex AI.
     *           System will pick a display name if unspecified.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\MigrationService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The ml.googleapis.com endpoint that this model version should
     * be migrated from. Example values:
     * * ml.googleapis.com
     * * us-centrall-ml.googleapis.com
     * * europe-west4-ml.googleapis.com
     * * asia-east1-ml.googleapis.com
     *
     * Generated from protobuf field <code>string endpoint = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getEndpoint()
    {
        return $this->endpoint;
    }

    /**
     * Required. The ml.googleapis.com endpoint that this model version should
     * be migrated from. Example values:
     * * ml.googleapis.com
     * * us-centrall-ml.googleapis.com
     * * europe-west4-ml.googleapis.com
     * * asia-east1-ml.googleapis.com
     *
     * Generated from protobuf field <code>string endpoint = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setEndpoint($var)
    {
        GPBUtil::checkString($var, True);
        $this->endpoint = $var;

        return $this;
    }

    /**
     * Required. Full resource name of ml engine model version.
     * Format: `projects/{project}/models/{model}/versions/{version}`.
     *
     * Generated from protobuf field <code>string model_version = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getModelVersion()
    {
        return $this->model_version;
    }

    /**
     * Required. Full resource name of ml engine model version.
     * Format: `projects/{project}/models/{model}/versions/{version}`.
     *
     * Generated from protobuf field <code>string model_version = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setModelVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->model_version = $var;

        return $this;
    }

    /**
     * Required. Display name of the model in Vertex AI.
     * System will pick a display name if unspecified.
     *
     * Generated from protobuf field <code>string model_display_name = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getModelDisplayName()
    {
        return $this->model_display_name;
    }

    /**
     * Required. Display name of the model in Vertex AI.
     * System will pick a display name if unspecified.
     *
     * Generated from protobuf field <code>string model_display_name = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setModelDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->model_display_name = $var;

        return $this;
    }

}


