<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/pipeline_job.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An instance of a machine learning PipelineJob.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.PipelineJob</code>
 */
class PipelineJob extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name of the PipelineJob.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $name = '';
    /**
     * The display name of the Pipeline.
     * The name can be up to 128 characters long and can consist of any UTF-8
     * characters.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     */
    private $display_name = '';
    /**
     * Output only. Pipeline creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $create_time = null;
    /**
     * Output only. Pipeline start time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $start_time = null;
    /**
     * Output only. Pipeline end time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $end_time = null;
    /**
     * Output only. Timestamp when this PipelineJob was most recently updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $update_time = null;
    /**
     * The spec of the pipeline.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct pipeline_spec = 7;</code>
     */
    private $pipeline_spec = null;
    /**
     * Output only. The detailed state of the job.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineState state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $state = 0;
    /**
     * Output only. The details of pipeline run. Not available in the list view.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineJobDetail job_detail = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $job_detail = null;
    /**
     * Output only. The error that occurred during pipeline execution.
     * Only populated when the pipeline's state is FAILED or CANCELLED.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $error = null;
    /**
     * The labels with user-defined metadata to organize PipelineJob.
     * Label keys and values can be no longer than 64 characters
     * (Unicode codepoints), can only contain lowercase letters, numeric
     * characters, underscores and dashes. International characters are allowed.
     * See https://goo.gl/xmQnxf for more information and examples of labels.
     *
     * Generated from protobuf field <code>map<string, string> labels = 11;</code>
     */
    private $labels;
    /**
     * Runtime config of the pipeline.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineJob.RuntimeConfig runtime_config = 12;</code>
     */
    private $runtime_config = null;
    /**
     * Customer-managed encryption key spec for a pipelineJob. If set, this
     * PipelineJob and all of its sub-resources will be secured by this key.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.EncryptionSpec encryption_spec = 16;</code>
     */
    private $encryption_spec = null;
    /**
     * The service account that the pipeline workload runs as.
     * If not specified, the Compute Engine default service account in the project
     * will be used.
     * See
     * https://cloud.google.com/compute/docs/access/service-accounts#default_service_account
     * Users starting the pipeline must have the `iam.serviceAccounts.actAs`
     * permission on this service account.
     *
     * Generated from protobuf field <code>string service_account = 17;</code>
     */
    private $service_account = '';
    /**
     * The full name of the Compute Engine
     * [network](https://cloud.google.com/compute/docs/networks-and-firewalls#networks) to which the
     * Pipeline Job's workload should be peered. For example,
     * `projects/12345/global/networks/myVPC`.
     * [Format](https://cloud.google.com/compute/docs/reference/rest/v1/networks/insert)
     * is of the form `projects/{project}/global/networks/{network}`.
     * Where {project} is a project number, as in `12345`, and {network} is a
     * network name.
     * Private services access must already be configured for the network.
     * Pipeline job will apply the network configuration to the Google Cloud
     * resources being launched, if applied, such as Vertex AI
     * Training or Dataflow job. If left unspecified, the workload is not peered
     * with any network.
     *
     * Generated from protobuf field <code>string network = 18 [(.google.api.resource_reference) = {</code>
     */
    private $network = '';
    /**
     * A template uri from where the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec],
     * if empty, will be downloaded.
     *
     * Generated from protobuf field <code>string template_uri = 19;</code>
     */
    private $template_uri = '';
    /**
     * Output only. Pipeline template metadata. Will fill up fields if
     * [PipelineJob.template_uri][google.cloud.aiplatform.v1.PipelineJob.template_uri]
     * is from supported template registry.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineTemplateMetadata template_metadata = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $template_metadata = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The resource name of the PipelineJob.
     *     @type string $display_name
     *           The display name of the Pipeline.
     *           The name can be up to 128 characters long and can consist of any UTF-8
     *           characters.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Pipeline creation time.
     *     @type \Google\Protobuf\Timestamp $start_time
     *           Output only. Pipeline start time.
     *     @type \Google\Protobuf\Timestamp $end_time
     *           Output only. Pipeline end time.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Timestamp when this PipelineJob was most recently updated.
     *     @type \Google\Protobuf\Struct $pipeline_spec
     *           The spec of the pipeline.
     *     @type int $state
     *           Output only. The detailed state of the job.
     *     @type \Google\Cloud\AIPlatform\V1\PipelineJobDetail $job_detail
     *           Output only. The details of pipeline run. Not available in the list view.
     *     @type \Google\Rpc\Status $error
     *           Output only. The error that occurred during pipeline execution.
     *           Only populated when the pipeline's state is FAILED or CANCELLED.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           The labels with user-defined metadata to organize PipelineJob.
     *           Label keys and values can be no longer than 64 characters
     *           (Unicode codepoints), can only contain lowercase letters, numeric
     *           characters, underscores and dashes. International characters are allowed.
     *           See https://goo.gl/xmQnxf for more information and examples of labels.
     *     @type \Google\Cloud\AIPlatform\V1\PipelineJob\RuntimeConfig $runtime_config
     *           Runtime config of the pipeline.
     *     @type \Google\Cloud\AIPlatform\V1\EncryptionSpec $encryption_spec
     *           Customer-managed encryption key spec for a pipelineJob. If set, this
     *           PipelineJob and all of its sub-resources will be secured by this key.
     *     @type string $service_account
     *           The service account that the pipeline workload runs as.
     *           If not specified, the Compute Engine default service account in the project
     *           will be used.
     *           See
     *           https://cloud.google.com/compute/docs/access/service-accounts#default_service_account
     *           Users starting the pipeline must have the `iam.serviceAccounts.actAs`
     *           permission on this service account.
     *     @type string $network
     *           The full name of the Compute Engine
     *           [network](https://cloud.google.com/compute/docs/networks-and-firewalls#networks) to which the
     *           Pipeline Job's workload should be peered. For example,
     *           `projects/12345/global/networks/myVPC`.
     *           [Format](https://cloud.google.com/compute/docs/reference/rest/v1/networks/insert)
     *           is of the form `projects/{project}/global/networks/{network}`.
     *           Where {project} is a project number, as in `12345`, and {network} is a
     *           network name.
     *           Private services access must already be configured for the network.
     *           Pipeline job will apply the network configuration to the Google Cloud
     *           resources being launched, if applied, such as Vertex AI
     *           Training or Dataflow job. If left unspecified, the workload is not peered
     *           with any network.
     *     @type string $template_uri
     *           A template uri from where the
     *           [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec],
     *           if empty, will be downloaded.
     *     @type \Google\Cloud\AIPlatform\V1\PipelineTemplateMetadata $template_metadata
     *           Output only. Pipeline template metadata. Will fill up fields if
     *           [PipelineJob.template_uri][google.cloud.aiplatform.v1.PipelineJob.template_uri]
     *           is from supported template registry.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\PipelineJob::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The resource name of the PipelineJob.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name of the PipelineJob.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The display name of the Pipeline.
     * The name can be up to 128 characters long and can consist of any UTF-8
     * characters.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The display name of the Pipeline.
     * The name can be up to 128 characters long and can consist of any UTF-8
     * characters.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Output only. Pipeline creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Pipeline creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Pipeline start time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getStartTime()
    {
        return $this->start_time;
    }

    public function hasStartTime()
    {
        return isset($this->start_time);
    }

    public function clearStartTime()
    {
        unset($this->start_time);
    }

    /**
     * Output only. Pipeline start time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->start_time = $var;

        return $this;
    }

    /**
     * Output only. Pipeline end time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEndTime()
    {
        return $this->end_time;
    }

    public function hasEndTime()
    {
        return isset($this->end_time);
    }

    public function clearEndTime()
    {
        unset($this->end_time);
    }

    /**
     * Output only. Pipeline end time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEndTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->end_time = $var;

        return $this;
    }

    /**
     * Output only. Timestamp when this PipelineJob was most recently updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Timestamp when this PipelineJob was most recently updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * The spec of the pipeline.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct pipeline_spec = 7;</code>
     * @return \Google\Protobuf\Struct|null
     */
    public function getPipelineSpec()
    {
        return $this->pipeline_spec;
    }

    public function hasPipelineSpec()
    {
        return isset($this->pipeline_spec);
    }

    public function clearPipelineSpec()
    {
        unset($this->pipeline_spec);
    }

    /**
     * The spec of the pipeline.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct pipeline_spec = 7;</code>
     * @param \Google\Protobuf\Struct $var
     * @return $this
     */
    public function setPipelineSpec($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Struct::class);
        $this->pipeline_spec = $var;

        return $this;
    }

    /**
     * Output only. The detailed state of the job.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineState state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The detailed state of the job.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineState state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AIPlatform\V1\PipelineState::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. The details of pipeline run. Not available in the list view.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineJobDetail job_detail = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AIPlatform\V1\PipelineJobDetail|null
     */
    public function getJobDetail()
    {
        return $this->job_detail;
    }

    public function hasJobDetail()
    {
        return isset($this->job_detail);
    }

    public function clearJobDetail()
    {
        unset($this->job_detail);
    }

    /**
     * Output only. The details of pipeline run. Not available in the list view.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineJobDetail job_detail = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AIPlatform\V1\PipelineJobDetail $var
     * @return $this
     */
    public function setJobDetail($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PipelineJobDetail::class);
        $this->job_detail = $var;

        return $this;
    }

    /**
     * Output only. The error that occurred during pipeline execution.
     * Only populated when the pipeline's state is FAILED or CANCELLED.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Rpc\Status|null
     */
    public function getError()
    {
        return $this->error;
    }

    public function hasError()
    {
        return isset($this->error);
    }

    public function clearError()
    {
        unset($this->error);
    }

    /**
     * Output only. The error that occurred during pipeline execution.
     * Only populated when the pipeline's state is FAILED or CANCELLED.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Rpc\Status $var
     * @return $this
     */
    public function setError($var)
    {
        GPBUtil::checkMessage($var, \Google\Rpc\Status::class);
        $this->error = $var;

        return $this;
    }

    /**
     * The labels with user-defined metadata to organize PipelineJob.
     * Label keys and values can be no longer than 64 characters
     * (Unicode codepoints), can only contain lowercase letters, numeric
     * characters, underscores and dashes. International characters are allowed.
     * See https://goo.gl/xmQnxf for more information and examples of labels.
     *
     * Generated from protobuf field <code>map<string, string> labels = 11;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * The labels with user-defined metadata to organize PipelineJob.
     * Label keys and values can be no longer than 64 characters
     * (Unicode codepoints), can only contain lowercase letters, numeric
     * characters, underscores and dashes. International characters are allowed.
     * See https://goo.gl/xmQnxf for more information and examples of labels.
     *
     * Generated from protobuf field <code>map<string, string> labels = 11;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Runtime config of the pipeline.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineJob.RuntimeConfig runtime_config = 12;</code>
     * @return \Google\Cloud\AIPlatform\V1\PipelineJob\RuntimeConfig|null
     */
    public function getRuntimeConfig()
    {
        return $this->runtime_config;
    }

    public function hasRuntimeConfig()
    {
        return isset($this->runtime_config);
    }

    public function clearRuntimeConfig()
    {
        unset($this->runtime_config);
    }

    /**
     * Runtime config of the pipeline.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineJob.RuntimeConfig runtime_config = 12;</code>
     * @param \Google\Cloud\AIPlatform\V1\PipelineJob\RuntimeConfig $var
     * @return $this
     */
    public function setRuntimeConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PipelineJob\RuntimeConfig::class);
        $this->runtime_config = $var;

        return $this;
    }

    /**
     * Customer-managed encryption key spec for a pipelineJob. If set, this
     * PipelineJob and all of its sub-resources will be secured by this key.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.EncryptionSpec encryption_spec = 16;</code>
     * @return \Google\Cloud\AIPlatform\V1\EncryptionSpec|null
     */
    public function getEncryptionSpec()
    {
        return $this->encryption_spec;
    }

    public function hasEncryptionSpec()
    {
        return isset($this->encryption_spec);
    }

    public function clearEncryptionSpec()
    {
        unset($this->encryption_spec);
    }

    /**
     * Customer-managed encryption key spec for a pipelineJob. If set, this
     * PipelineJob and all of its sub-resources will be secured by this key.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.EncryptionSpec encryption_spec = 16;</code>
     * @param \Google\Cloud\AIPlatform\V1\EncryptionSpec $var
     * @return $this
     */
    public function setEncryptionSpec($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\EncryptionSpec::class);
        $this->encryption_spec = $var;

        return $this;
    }

    /**
     * The service account that the pipeline workload runs as.
     * If not specified, the Compute Engine default service account in the project
     * will be used.
     * See
     * https://cloud.google.com/compute/docs/access/service-accounts#default_service_account
     * Users starting the pipeline must have the `iam.serviceAccounts.actAs`
     * permission on this service account.
     *
     * Generated from protobuf field <code>string service_account = 17;</code>
     * @return string
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    /**
     * The service account that the pipeline workload runs as.
     * If not specified, the Compute Engine default service account in the project
     * will be used.
     * See
     * https://cloud.google.com/compute/docs/access/service-accounts#default_service_account
     * Users starting the pipeline must have the `iam.serviceAccounts.actAs`
     * permission on this service account.
     *
     * Generated from protobuf field <code>string service_account = 17;</code>
     * @param string $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_account = $var;

        return $this;
    }

    /**
     * The full name of the Compute Engine
     * [network](https://cloud.google.com/compute/docs/networks-and-firewalls#networks) to which the
     * Pipeline Job's workload should be peered. For example,
     * `projects/12345/global/networks/myVPC`.
     * [Format](https://cloud.google.com/compute/docs/reference/rest/v1/networks/insert)
     * is of the form `projects/{project}/global/networks/{network}`.
     * Where {project} is a project number, as in `12345`, and {network} is a
     * network name.
     * Private services access must already be configured for the network.
     * Pipeline job will apply the network configuration to the Google Cloud
     * resources being launched, if applied, such as Vertex AI
     * Training or Dataflow job. If left unspecified, the workload is not peered
     * with any network.
     *
     * Generated from protobuf field <code>string network = 18 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getNetwork()
    {
        return $this->network;
    }

    /**
     * The full name of the Compute Engine
     * [network](https://cloud.google.com/compute/docs/networks-and-firewalls#networks) to which the
     * Pipeline Job's workload should be peered. For example,
     * `projects/12345/global/networks/myVPC`.
     * [Format](https://cloud.google.com/compute/docs/reference/rest/v1/networks/insert)
     * is of the form `projects/{project}/global/networks/{network}`.
     * Where {project} is a project number, as in `12345`, and {network} is a
     * network name.
     * Private services access must already be configured for the network.
     * Pipeline job will apply the network configuration to the Google Cloud
     * resources being launched, if applied, such as Vertex AI
     * Training or Dataflow job. If left unspecified, the workload is not peered
     * with any network.
     *
     * Generated from protobuf field <code>string network = 18 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setNetwork($var)
    {
        GPBUtil::checkString($var, True);
        $this->network = $var;

        return $this;
    }

    /**
     * A template uri from where the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec],
     * if empty, will be downloaded.
     *
     * Generated from protobuf field <code>string template_uri = 19;</code>
     * @return string
     */
    public function getTemplateUri()
    {
        return $this->template_uri;
    }

    /**
     * A template uri from where the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec],
     * if empty, will be downloaded.
     *
     * Generated from protobuf field <code>string template_uri = 19;</code>
     * @param string $var
     * @return $this
     */
    public function setTemplateUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->template_uri = $var;

        return $this;
    }

    /**
     * Output only. Pipeline template metadata. Will fill up fields if
     * [PipelineJob.template_uri][google.cloud.aiplatform.v1.PipelineJob.template_uri]
     * is from supported template registry.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineTemplateMetadata template_metadata = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AIPlatform\V1\PipelineTemplateMetadata|null
     */
    public function getTemplateMetadata()
    {
        return $this->template_metadata;
    }

    public function hasTemplateMetadata()
    {
        return isset($this->template_metadata);
    }

    public function clearTemplateMetadata()
    {
        unset($this->template_metadata);
    }

    /**
     * Output only. Pipeline template metadata. Will fill up fields if
     * [PipelineJob.template_uri][google.cloud.aiplatform.v1.PipelineJob.template_uri]
     * is from supported template registry.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PipelineTemplateMetadata template_metadata = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AIPlatform\V1\PipelineTemplateMetadata $var
     * @return $this
     */
    public function setTemplateMetadata($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PipelineTemplateMetadata::class);
        $this->template_metadata = $var;

        return $this;
    }

}

