<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/alloydb/v1beta/resources.proto

namespace Google\Cloud\AlloyDb\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * SupportedDatabaseFlag gives general information about a database flag,
 * like type and allowed values. This is a static value that is defined
 * on the server side, and it cannot be modified by callers.
 * To set the Database flags on a particular Instance, a caller should modify
 * the Instance.database_flags field.
 *
 * Generated from protobuf message <code>google.cloud.alloydb.v1beta.SupportedDatabaseFlag</code>
 */
class SupportedDatabaseFlag extends \Google\Protobuf\Internal\Message
{
    /**
     * The name of the flag resource, following Google Cloud conventions, e.g.:
     *  * projects/{project}/locations/{location}/flags/{flag}
     * This field currently has no semantic meaning.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * The name of the database flag, e.g. "max_allowed_packets".
     * The is a possibly key for the Instance.database_flags map field.
     *
     * Generated from protobuf field <code>string flag_name = 2;</code>
     */
    protected $flag_name = '';
    /**
     * Generated from protobuf field <code>.google.cloud.alloydb.v1beta.SupportedDatabaseFlag.ValueType value_type = 3;</code>
     */
    protected $value_type = 0;
    /**
     * Whether the database flag accepts multiple values. If true,
     * a comma-separated list of stringified values may be specified.
     *
     * Generated from protobuf field <code>bool accepts_multiple_values = 4;</code>
     */
    protected $accepts_multiple_values = false;
    /**
     * Major database engine versions for which this flag is supported.
     *
     * Generated from protobuf field <code>repeated .google.cloud.alloydb.v1beta.DatabaseVersion supported_db_versions = 5;</code>
     */
    private $supported_db_versions;
    /**
     * Whether setting or updating this flag on an Instance requires a database
     * restart. If a flag that requires database restart is set, the backend
     * will automatically restart the database (making sure to satisfy any
     * availability SLO's).
     *
     * Generated from protobuf field <code>bool requires_db_restart = 6;</code>
     */
    protected $requires_db_restart = false;
    protected $restrictions;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\StringRestrictions $string_restrictions
     *           Restriction on STRING type value.
     *     @type \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\IntegerRestrictions $integer_restrictions
     *           Restriction on INTEGER type value.
     *     @type string $name
     *           The name of the flag resource, following Google Cloud conventions, e.g.:
     *            * projects/{project}/locations/{location}/flags/{flag}
     *           This field currently has no semantic meaning.
     *     @type string $flag_name
     *           The name of the database flag, e.g. "max_allowed_packets".
     *           The is a possibly key for the Instance.database_flags map field.
     *     @type int $value_type
     *     @type bool $accepts_multiple_values
     *           Whether the database flag accepts multiple values. If true,
     *           a comma-separated list of stringified values may be specified.
     *     @type array<int>|\Google\Protobuf\Internal\RepeatedField $supported_db_versions
     *           Major database engine versions for which this flag is supported.
     *     @type bool $requires_db_restart
     *           Whether setting or updating this flag on an Instance requires a database
     *           restart. If a flag that requires database restart is set, the backend
     *           will automatically restart the database (making sure to satisfy any
     *           availability SLO's).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Alloydb\V1Beta\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Restriction on STRING type value.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1beta.SupportedDatabaseFlag.StringRestrictions string_restrictions = 7;</code>
     * @return \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\StringRestrictions|null
     */
    public function getStringRestrictions()
    {
        return $this->readOneof(7);
    }

    public function hasStringRestrictions()
    {
        return $this->hasOneof(7);
    }

    /**
     * Restriction on STRING type value.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1beta.SupportedDatabaseFlag.StringRestrictions string_restrictions = 7;</code>
     * @param \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\StringRestrictions $var
     * @return $this
     */
    public function setStringRestrictions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\StringRestrictions::class);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     * Restriction on INTEGER type value.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1beta.SupportedDatabaseFlag.IntegerRestrictions integer_restrictions = 8;</code>
     * @return \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\IntegerRestrictions|null
     */
    public function getIntegerRestrictions()
    {
        return $this->readOneof(8);
    }

    public function hasIntegerRestrictions()
    {
        return $this->hasOneof(8);
    }

    /**
     * Restriction on INTEGER type value.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1beta.SupportedDatabaseFlag.IntegerRestrictions integer_restrictions = 8;</code>
     * @param \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\IntegerRestrictions $var
     * @return $this
     */
    public function setIntegerRestrictions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\IntegerRestrictions::class);
        $this->writeOneof(8, $var);

        return $this;
    }

    /**
     * The name of the flag resource, following Google Cloud conventions, e.g.:
     *  * projects/{project}/locations/{location}/flags/{flag}
     * This field currently has no semantic meaning.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The name of the flag resource, following Google Cloud conventions, e.g.:
     *  * projects/{project}/locations/{location}/flags/{flag}
     * This field currently has no semantic meaning.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The name of the database flag, e.g. "max_allowed_packets".
     * The is a possibly key for the Instance.database_flags map field.
     *
     * Generated from protobuf field <code>string flag_name = 2;</code>
     * @return string
     */
    public function getFlagName()
    {
        return $this->flag_name;
    }

    /**
     * The name of the database flag, e.g. "max_allowed_packets".
     * The is a possibly key for the Instance.database_flags map field.
     *
     * Generated from protobuf field <code>string flag_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFlagName($var)
    {
        GPBUtil::checkString($var, True);
        $this->flag_name = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>.google.cloud.alloydb.v1beta.SupportedDatabaseFlag.ValueType value_type = 3;</code>
     * @return int
     */
    public function getValueType()
    {
        return $this->value_type;
    }

    /**
     * Generated from protobuf field <code>.google.cloud.alloydb.v1beta.SupportedDatabaseFlag.ValueType value_type = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setValueType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AlloyDb\V1beta\SupportedDatabaseFlag\ValueType::class);
        $this->value_type = $var;

        return $this;
    }

    /**
     * Whether the database flag accepts multiple values. If true,
     * a comma-separated list of stringified values may be specified.
     *
     * Generated from protobuf field <code>bool accepts_multiple_values = 4;</code>
     * @return bool
     */
    public function getAcceptsMultipleValues()
    {
        return $this->accepts_multiple_values;
    }

    /**
     * Whether the database flag accepts multiple values. If true,
     * a comma-separated list of stringified values may be specified.
     *
     * Generated from protobuf field <code>bool accepts_multiple_values = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setAcceptsMultipleValues($var)
    {
        GPBUtil::checkBool($var);
        $this->accepts_multiple_values = $var;

        return $this;
    }

    /**
     * Major database engine versions for which this flag is supported.
     *
     * Generated from protobuf field <code>repeated .google.cloud.alloydb.v1beta.DatabaseVersion supported_db_versions = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSupportedDbVersions()
    {
        return $this->supported_db_versions;
    }

    /**
     * Major database engine versions for which this flag is supported.
     *
     * Generated from protobuf field <code>repeated .google.cloud.alloydb.v1beta.DatabaseVersion supported_db_versions = 5;</code>
     * @param array<int>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSupportedDbVersions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Google\Cloud\AlloyDb\V1beta\DatabaseVersion::class);
        $this->supported_db_versions = $arr;

        return $this;
    }

    /**
     * Whether setting or updating this flag on an Instance requires a database
     * restart. If a flag that requires database restart is set, the backend
     * will automatically restart the database (making sure to satisfy any
     * availability SLO's).
     *
     * Generated from protobuf field <code>bool requires_db_restart = 6;</code>
     * @return bool
     */
    public function getRequiresDbRestart()
    {
        return $this->requires_db_restart;
    }

    /**
     * Whether setting or updating this flag on an Instance requires a database
     * restart. If a flag that requires database restart is set, the backend
     * will automatically restart the database (making sure to satisfy any
     * availability SLO's).
     *
     * Generated from protobuf field <code>bool requires_db_restart = 6;</code>
     * @param bool $var
     * @return $this
     */
    public function setRequiresDbRestart($var)
    {
        GPBUtil::checkBool($var);
        $this->requires_db_restart = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getRestrictions()
    {
        return $this->whichOneof("restrictions");
    }

}

