<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apigeeregistry/v1/registry_service.proto

namespace Google\Cloud\ApigeeRegistry\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for CreateArtifact.
 *
 * Generated from protobuf message <code>google.cloud.apigeeregistry.v1.CreateArtifactRequest</code>
 */
class CreateArtifactRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent, which owns this collection of artifacts.
     * Format: `{parent}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Required. The artifact to create.
     *
     * Generated from protobuf field <code>.google.cloud.apigeeregistry.v1.Artifact artifact = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $artifact = null;
    /**
     * Required. The ID to use for the artifact, which will become the final component of
     * the artifact's resource name.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     * Following AIP-162, IDs must not have the form of a UUID.
     *
     * Generated from protobuf field <code>string artifact_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $artifact_id = '';

    /**
     * @param string                                   $parent     Required. The parent, which owns this collection of artifacts.
     *                                                             Format: `{parent}`
     *                                                             Please see {@see RegistryClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\ApigeeRegistry\V1\Artifact $artifact   Required. The artifact to create.
     * @param string                                   $artifactId Required. The ID to use for the artifact, which will become the final component of
     *                                                             the artifact's resource name.
     *
     *                                                             This value should be 4-63 characters, and valid characters
     *                                                             are /[a-z][0-9]-/.
     *
     *                                                             Following AIP-162, IDs must not have the form of a UUID.
     *
     * @return \Google\Cloud\ApigeeRegistry\V1\CreateArtifactRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\ApigeeRegistry\V1\Artifact $artifact, string $artifactId): self
    {
        return (new self())
            ->setParent($parent)
            ->setArtifact($artifact)
            ->setArtifactId($artifactId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent, which owns this collection of artifacts.
     *           Format: `{parent}`
     *     @type \Google\Cloud\ApigeeRegistry\V1\Artifact $artifact
     *           Required. The artifact to create.
     *     @type string $artifact_id
     *           Required. The ID to use for the artifact, which will become the final component of
     *           the artifact's resource name.
     *           This value should be 4-63 characters, and valid characters
     *           are /[a-z][0-9]-/.
     *           Following AIP-162, IDs must not have the form of a UUID.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apigeeregistry\V1\RegistryService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent, which owns this collection of artifacts.
     * Format: `{parent}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent, which owns this collection of artifacts.
     * Format: `{parent}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The artifact to create.
     *
     * Generated from protobuf field <code>.google.cloud.apigeeregistry.v1.Artifact artifact = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ApigeeRegistry\V1\Artifact|null
     */
    public function getArtifact()
    {
        return $this->artifact;
    }

    public function hasArtifact()
    {
        return isset($this->artifact);
    }

    public function clearArtifact()
    {
        unset($this->artifact);
    }

    /**
     * Required. The artifact to create.
     *
     * Generated from protobuf field <code>.google.cloud.apigeeregistry.v1.Artifact artifact = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ApigeeRegistry\V1\Artifact $var
     * @return $this
     */
    public function setArtifact($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ApigeeRegistry\V1\Artifact::class);
        $this->artifact = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the artifact, which will become the final component of
     * the artifact's resource name.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     * Following AIP-162, IDs must not have the form of a UUID.
     *
     * Generated from protobuf field <code>string artifact_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getArtifactId()
    {
        return $this->artifact_id;
    }

    /**
     * Required. The ID to use for the artifact, which will become the final component of
     * the artifact's resource name.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     * Following AIP-162, IDs must not have the form of a UUID.
     *
     * Generated from protobuf field <code>string artifact_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setArtifactId($var)
    {
        GPBUtil::checkString($var, True);
        $this->artifact_id = $var;

        return $this;
    }

}

