<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/bigquery/datatransfer/v1/datatransfer.proto

namespace Google\Cloud\BigQuery\DataTransfer\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A request to get user facing log messages associated with data transfer run.
 *
 * Generated from protobuf message <code>google.cloud.bigquery.datatransfer.v1.ListTransferLogsRequest</code>
 */
class ListTransferLogsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Transfer run name in the form:
     * `projects/{project_id}/transferConfigs/{config_id}/runs/{run_id}` or
     * `projects/{project_id}/locations/{location_id}/transferConfigs/{config_id}/runs/{run_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Pagination token, which can be used to request a specific page
     * of `ListTransferLogsRequest` list results. For multiple-page
     * results, `ListTransferLogsResponse` outputs
     * a `next_page` token, which can be used as the
     * `page_token` value to request the next page of list results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    private $page_token = '';
    /**
     * Page size. The default page size is the maximum value of 1000 results.
     *
     * Generated from protobuf field <code>int32 page_size = 5;</code>
     */
    private $page_size = 0;
    /**
     * Message types to return. If not populated - INFO, WARNING and ERROR
     * messages are returned.
     *
     * Generated from protobuf field <code>repeated .google.cloud.bigquery.datatransfer.v1.TransferMessage.MessageSeverity message_types = 6;</code>
     */
    private $message_types;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Transfer run name in the form:
     *           `projects/{project_id}/transferConfigs/{config_id}/runs/{run_id}` or
     *           `projects/{project_id}/locations/{location_id}/transferConfigs/{config_id}/runs/{run_id}`
     *     @type string $page_token
     *           Pagination token, which can be used to request a specific page
     *           of `ListTransferLogsRequest` list results. For multiple-page
     *           results, `ListTransferLogsResponse` outputs
     *           a `next_page` token, which can be used as the
     *           `page_token` value to request the next page of list results.
     *     @type int $page_size
     *           Page size. The default page size is the maximum value of 1000 results.
     *     @type array<int>|\Google\Protobuf\Internal\RepeatedField $message_types
     *           Message types to return. If not populated - INFO, WARNING and ERROR
     *           messages are returned.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Bigquery\Datatransfer\V1\Datatransfer::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Transfer run name in the form:
     * `projects/{project_id}/transferConfigs/{config_id}/runs/{run_id}` or
     * `projects/{project_id}/locations/{location_id}/transferConfigs/{config_id}/runs/{run_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Transfer run name in the form:
     * `projects/{project_id}/transferConfigs/{config_id}/runs/{run_id}` or
     * `projects/{project_id}/locations/{location_id}/transferConfigs/{config_id}/runs/{run_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Pagination token, which can be used to request a specific page
     * of `ListTransferLogsRequest` list results. For multiple-page
     * results, `ListTransferLogsResponse` outputs
     * a `next_page` token, which can be used as the
     * `page_token` value to request the next page of list results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Pagination token, which can be used to request a specific page
     * of `ListTransferLogsRequest` list results. For multiple-page
     * results, `ListTransferLogsResponse` outputs
     * a `next_page` token, which can be used as the
     * `page_token` value to request the next page of list results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Page size. The default page size is the maximum value of 1000 results.
     *
     * Generated from protobuf field <code>int32 page_size = 5;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Page size. The default page size is the maximum value of 1000 results.
     *
     * Generated from protobuf field <code>int32 page_size = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Message types to return. If not populated - INFO, WARNING and ERROR
     * messages are returned.
     *
     * Generated from protobuf field <code>repeated .google.cloud.bigquery.datatransfer.v1.TransferMessage.MessageSeverity message_types = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getMessageTypes()
    {
        return $this->message_types;
    }

    /**
     * Message types to return. If not populated - INFO, WARNING and ERROR
     * messages are returned.
     *
     * Generated from protobuf field <code>repeated .google.cloud.bigquery.datatransfer.v1.TransferMessage.MessageSeverity message_types = 6;</code>
     * @param array<int>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setMessageTypes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Google\Cloud\BigQuery\DataTransfer\V1\TransferMessage\MessageSeverity::class);
        $this->message_types = $arr;

        return $this;
    }

}

