<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/bigquery/reservation/v1/reservation.proto

namespace Google\Cloud\BigQuery\Reservation\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request for
 * [ReservationService.MoveAssignment][google.cloud.bigquery.reservation.v1.ReservationService.MoveAssignment].
 * **Note**: "bigquery.reservationAssignments.create" permission is required on
 * the destination_id.
 * **Note**: "bigquery.reservationAssignments.create" and
 * "bigquery.reservationAssignments.delete" permission are required on the
 * related assignee.
 *
 * Generated from protobuf message <code>google.cloud.bigquery.reservation.v1.MoveAssignmentRequest</code>
 */
class MoveAssignmentRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the assignment,
     * e.g.
     * `projects/myproject/locations/US/reservations/team1-prod/assignments/123`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $name = '';
    /**
     * The new reservation ID, e.g.:
     *   `projects/myotherproject/locations/US/reservations/team2-prod`
     *
     * Generated from protobuf field <code>string destination_id = 3 [(.google.api.resource_reference) = {</code>
     */
    private $destination_id = '';
    /**
     * The optional assignment ID. A new assignment name is generated if this
     * field is empty.
     * This field can contain only lowercase alphanumeric characters or dashes.
     * Max length is 64 characters.
     *
     * Generated from protobuf field <code>string assignment_id = 5;</code>
     */
    private $assignment_id = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The resource name of the assignment,
     *           e.g.
     *           `projects/myproject/locations/US/reservations/team1-prod/assignments/123`
     *     @type string $destination_id
     *           The new reservation ID, e.g.:
     *             `projects/myotherproject/locations/US/reservations/team2-prod`
     *     @type string $assignment_id
     *           The optional assignment ID. A new assignment name is generated if this
     *           field is empty.
     *           This field can contain only lowercase alphanumeric characters or dashes.
     *           Max length is 64 characters.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Bigquery\Reservation\V1\Reservation::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the assignment,
     * e.g.
     * `projects/myproject/locations/US/reservations/team1-prod/assignments/123`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The resource name of the assignment,
     * e.g.
     * `projects/myproject/locations/US/reservations/team1-prod/assignments/123`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The new reservation ID, e.g.:
     *   `projects/myotherproject/locations/US/reservations/team2-prod`
     *
     * Generated from protobuf field <code>string destination_id = 3 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getDestinationId()
    {
        return $this->destination_id;
    }

    /**
     * The new reservation ID, e.g.:
     *   `projects/myotherproject/locations/US/reservations/team2-prod`
     *
     * Generated from protobuf field <code>string destination_id = 3 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setDestinationId($var)
    {
        GPBUtil::checkString($var, True);
        $this->destination_id = $var;

        return $this;
    }

    /**
     * The optional assignment ID. A new assignment name is generated if this
     * field is empty.
     * This field can contain only lowercase alphanumeric characters or dashes.
     * Max length is 64 characters.
     *
     * Generated from protobuf field <code>string assignment_id = 5;</code>
     * @return string
     */
    public function getAssignmentId()
    {
        return $this->assignment_id;
    }

    /**
     * The optional assignment ID. A new assignment name is generated if this
     * field is empty.
     * This field can contain only lowercase alphanumeric characters or dashes.
     * Max length is 64 characters.
     *
     * Generated from protobuf field <code>string assignment_id = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setAssignmentId($var)
    {
        GPBUtil::checkString($var, True);
        $this->assignment_id = $var;

        return $this;
    }

}

