<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/bigtable/admin/v2/bigtable_instance_admin.proto

namespace Google\Cloud\Bigtable\Admin\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for BigtableInstanceAdmin.ListHotTablets.
 *
 * Generated from protobuf message <code>google.bigtable.admin.v2.ListHotTabletsRequest</code>
 */
class ListHotTabletsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The cluster name to list hot tablets.
     * Value is in the following form:
     * `projects/{project}/instances/{instance}/clusters/{cluster}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * The start time to list hot tablets. The hot tablets in the response will
     * have start times between the requested start time and end time. Start time
     * defaults to Now if it is unset, and end time defaults to Now - 24 hours if
     * it is unset. The start time should be less than the end time, and the
     * maximum allowed time range between start time and end time is 48 hours.
     * Start time and end time should have values between Now and Now - 14 days.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 2;</code>
     */
    private $start_time = null;
    /**
     * The end time to list hot tablets.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 3;</code>
     */
    private $end_time = null;
    /**
     * Maximum number of results per page.
     * A page_size that is empty or zero lets the server choose the number of
     * items to return. A page_size which is strictly positive will return at most
     * that many items. A negative page_size will cause an error.
     * Following the first request, subsequent paginated calls do not need a
     * page_size field. If a page_size is set in subsequent calls, it must match
     * the page_size given in the first request.
     *
     * Generated from protobuf field <code>int32 page_size = 4;</code>
     */
    private $page_size = 0;
    /**
     * The value of `next_page_token` returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 5;</code>
     */
    private $page_token = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The cluster name to list hot tablets.
     *           Value is in the following form:
     *           `projects/{project}/instances/{instance}/clusters/{cluster}`.
     *     @type \Google\Protobuf\Timestamp $start_time
     *           The start time to list hot tablets. The hot tablets in the response will
     *           have start times between the requested start time and end time. Start time
     *           defaults to Now if it is unset, and end time defaults to Now - 24 hours if
     *           it is unset. The start time should be less than the end time, and the
     *           maximum allowed time range between start time and end time is 48 hours.
     *           Start time and end time should have values between Now and Now - 14 days.
     *     @type \Google\Protobuf\Timestamp $end_time
     *           The end time to list hot tablets.
     *     @type int $page_size
     *           Maximum number of results per page.
     *           A page_size that is empty or zero lets the server choose the number of
     *           items to return. A page_size which is strictly positive will return at most
     *           that many items. A negative page_size will cause an error.
     *           Following the first request, subsequent paginated calls do not need a
     *           page_size field. If a page_size is set in subsequent calls, it must match
     *           the page_size given in the first request.
     *     @type string $page_token
     *           The value of `next_page_token` returned by a previous call.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Bigtable\Admin\V2\BigtableInstanceAdmin::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The cluster name to list hot tablets.
     * Value is in the following form:
     * `projects/{project}/instances/{instance}/clusters/{cluster}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The cluster name to list hot tablets.
     * Value is in the following form:
     * `projects/{project}/instances/{instance}/clusters/{cluster}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The start time to list hot tablets. The hot tablets in the response will
     * have start times between the requested start time and end time. Start time
     * defaults to Now if it is unset, and end time defaults to Now - 24 hours if
     * it is unset. The start time should be less than the end time, and the
     * maximum allowed time range between start time and end time is 48 hours.
     * Start time and end time should have values between Now and Now - 14 days.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 2;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getStartTime()
    {
        return $this->start_time;
    }

    public function hasStartTime()
    {
        return isset($this->start_time);
    }

    public function clearStartTime()
    {
        unset($this->start_time);
    }

    /**
     * The start time to list hot tablets. The hot tablets in the response will
     * have start times between the requested start time and end time. Start time
     * defaults to Now if it is unset, and end time defaults to Now - 24 hours if
     * it is unset. The start time should be less than the end time, and the
     * maximum allowed time range between start time and end time is 48 hours.
     * Start time and end time should have values between Now and Now - 14 days.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 2;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->start_time = $var;

        return $this;
    }

    /**
     * The end time to list hot tablets.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 3;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEndTime()
    {
        return $this->end_time;
    }

    public function hasEndTime()
    {
        return isset($this->end_time);
    }

    public function clearEndTime()
    {
        unset($this->end_time);
    }

    /**
     * The end time to list hot tablets.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 3;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEndTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->end_time = $var;

        return $this;
    }

    /**
     * Maximum number of results per page.
     * A page_size that is empty or zero lets the server choose the number of
     * items to return. A page_size which is strictly positive will return at most
     * that many items. A negative page_size will cause an error.
     * Following the first request, subsequent paginated calls do not need a
     * page_size field. If a page_size is set in subsequent calls, it must match
     * the page_size given in the first request.
     *
     * Generated from protobuf field <code>int32 page_size = 4;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Maximum number of results per page.
     * A page_size that is empty or zero lets the server choose the number of
     * items to return. A page_size which is strictly positive will return at most
     * that many items. A negative page_size will cause an error.
     * Following the first request, subsequent paginated calls do not need a
     * page_size field. If a page_size is set in subsequent calls, it must match
     * the page_size given in the first request.
     *
     * Generated from protobuf field <code>int32 page_size = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * The value of `next_page_token` returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 5;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * The value of `next_page_token` returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

