<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/bigtable/v2/data.proto

namespace Google\Cloud\Bigtable\V2\Mutation;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Mutation which deletes cells from the specified column, optionally
 * restricting the deletions to a given timestamp range.
 *
 * Generated from protobuf message <code>google.bigtable.v2.Mutation.DeleteFromColumn</code>
 */
class DeleteFromColumn extends \Google\Protobuf\Internal\Message
{
    /**
     * The name of the family from which cells should be deleted.
     * Must match `[-_.a-zA-Z0-9]+`
     *
     * Generated from protobuf field <code>string family_name = 1;</code>
     */
    private $family_name = '';
    /**
     * The qualifier of the column from which cells should be deleted.
     * Can be any byte string, including the empty string.
     *
     * Generated from protobuf field <code>bytes column_qualifier = 2;</code>
     */
    private $column_qualifier = '';
    /**
     * The range of timestamps within which cells should be deleted.
     *
     * Generated from protobuf field <code>.google.bigtable.v2.TimestampRange time_range = 3;</code>
     */
    private $time_range = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $family_name
     *           The name of the family from which cells should be deleted.
     *           Must match `[-_.a-zA-Z0-9]+`
     *     @type string $column_qualifier
     *           The qualifier of the column from which cells should be deleted.
     *           Can be any byte string, including the empty string.
     *     @type \Google\Cloud\Bigtable\V2\TimestampRange $time_range
     *           The range of timestamps within which cells should be deleted.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Bigtable\V2\Data::initOnce();
        parent::__construct($data);
    }

    /**
     * The name of the family from which cells should be deleted.
     * Must match `[-_.a-zA-Z0-9]+`
     *
     * Generated from protobuf field <code>string family_name = 1;</code>
     * @return string
     */
    public function getFamilyName()
    {
        return $this->family_name;
    }

    /**
     * The name of the family from which cells should be deleted.
     * Must match `[-_.a-zA-Z0-9]+`
     *
     * Generated from protobuf field <code>string family_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setFamilyName($var)
    {
        GPBUtil::checkString($var, True);
        $this->family_name = $var;

        return $this;
    }

    /**
     * The qualifier of the column from which cells should be deleted.
     * Can be any byte string, including the empty string.
     *
     * Generated from protobuf field <code>bytes column_qualifier = 2;</code>
     * @return string
     */
    public function getColumnQualifier()
    {
        return $this->column_qualifier;
    }

    /**
     * The qualifier of the column from which cells should be deleted.
     * Can be any byte string, including the empty string.
     *
     * Generated from protobuf field <code>bytes column_qualifier = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setColumnQualifier($var)
    {
        GPBUtil::checkString($var, False);
        $this->column_qualifier = $var;

        return $this;
    }

    /**
     * The range of timestamps within which cells should be deleted.
     *
     * Generated from protobuf field <code>.google.bigtable.v2.TimestampRange time_range = 3;</code>
     * @return \Google\Cloud\Bigtable\V2\TimestampRange|null
     */
    public function getTimeRange()
    {
        return $this->time_range;
    }

    public function hasTimeRange()
    {
        return isset($this->time_range);
    }

    public function clearTimeRange()
    {
        unset($this->time_range);
    }

    /**
     * The range of timestamps within which cells should be deleted.
     *
     * Generated from protobuf field <code>.google.bigtable.v2.TimestampRange time_range = 3;</code>
     * @param \Google\Cloud\Bigtable\V2\TimestampRange $var
     * @return $this
     */
    public function setTimeRange($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Bigtable\V2\TimestampRange::class);
        $this->time_range = $var;

        return $this;
    }

}

// Adding a class alias for backwards compatibility with the previous class name.
class_alias(DeleteFromColumn::class, \Google\Cloud\Bigtable\V2\Mutation_DeleteFromColumn::class);

