<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/cloudbuild/v1/cloudbuild.proto

namespace Google\Cloud\Build\V1\Artifacts;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Maven artifact to upload to Artifact Registry upon successful completion
 * of all build steps.
 *
 * Generated from protobuf message <code>google.devtools.cloudbuild.v1.Artifacts.MavenArtifact</code>
 */
class MavenArtifact extends \Google\Protobuf\Internal\Message
{
    /**
     * Artifact Registry repository, in the form
     * "https://$REGION-maven.pkg.dev/$PROJECT/$REPOSITORY"
     * Artifact in the workspace specified by path will be uploaded to
     * Artifact Registry with this location as a prefix.
     *
     * Generated from protobuf field <code>string repository = 1;</code>
     */
    private $repository = '';
    /**
     * Path to an artifact in the build's workspace to be uploaded to
     * Artifact Registry.
     * This can be either an absolute path,
     * e.g. /workspace/my-app/target/my-app-1.0.SNAPSHOT.jar
     * or a relative path from /workspace,
     * e.g. my-app/target/my-app-1.0.SNAPSHOT.jar.
     *
     * Generated from protobuf field <code>string path = 2;</code>
     */
    private $path = '';
    /**
     * Maven `artifactId` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string artifact_id = 3;</code>
     */
    private $artifact_id = '';
    /**
     * Maven `groupId` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string group_id = 4;</code>
     */
    private $group_id = '';
    /**
     * Maven `version` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string version = 5;</code>
     */
    private $version = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $repository
     *           Artifact Registry repository, in the form
     *           "https://$REGION-maven.pkg.dev/$PROJECT/$REPOSITORY"
     *           Artifact in the workspace specified by path will be uploaded to
     *           Artifact Registry with this location as a prefix.
     *     @type string $path
     *           Path to an artifact in the build's workspace to be uploaded to
     *           Artifact Registry.
     *           This can be either an absolute path,
     *           e.g. /workspace/my-app/target/my-app-1.0.SNAPSHOT.jar
     *           or a relative path from /workspace,
     *           e.g. my-app/target/my-app-1.0.SNAPSHOT.jar.
     *     @type string $artifact_id
     *           Maven `artifactId` value used when uploading the artifact to Artifact
     *           Registry.
     *     @type string $group_id
     *           Maven `groupId` value used when uploading the artifact to Artifact
     *           Registry.
     *     @type string $version
     *           Maven `version` value used when uploading the artifact to Artifact
     *           Registry.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Devtools\Cloudbuild\V1\Cloudbuild::initOnce();
        parent::__construct($data);
    }

    /**
     * Artifact Registry repository, in the form
     * "https://$REGION-maven.pkg.dev/$PROJECT/$REPOSITORY"
     * Artifact in the workspace specified by path will be uploaded to
     * Artifact Registry with this location as a prefix.
     *
     * Generated from protobuf field <code>string repository = 1;</code>
     * @return string
     */
    public function getRepository()
    {
        return $this->repository;
    }

    /**
     * Artifact Registry repository, in the form
     * "https://$REGION-maven.pkg.dev/$PROJECT/$REPOSITORY"
     * Artifact in the workspace specified by path will be uploaded to
     * Artifact Registry with this location as a prefix.
     *
     * Generated from protobuf field <code>string repository = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setRepository($var)
    {
        GPBUtil::checkString($var, True);
        $this->repository = $var;

        return $this;
    }

    /**
     * Path to an artifact in the build's workspace to be uploaded to
     * Artifact Registry.
     * This can be either an absolute path,
     * e.g. /workspace/my-app/target/my-app-1.0.SNAPSHOT.jar
     * or a relative path from /workspace,
     * e.g. my-app/target/my-app-1.0.SNAPSHOT.jar.
     *
     * Generated from protobuf field <code>string path = 2;</code>
     * @return string
     */
    public function getPath()
    {
        return $this->path;
    }

    /**
     * Path to an artifact in the build's workspace to be uploaded to
     * Artifact Registry.
     * This can be either an absolute path,
     * e.g. /workspace/my-app/target/my-app-1.0.SNAPSHOT.jar
     * or a relative path from /workspace,
     * e.g. my-app/target/my-app-1.0.SNAPSHOT.jar.
     *
     * Generated from protobuf field <code>string path = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->path = $var;

        return $this;
    }

    /**
     * Maven `artifactId` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string artifact_id = 3;</code>
     * @return string
     */
    public function getArtifactId()
    {
        return $this->artifact_id;
    }

    /**
     * Maven `artifactId` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string artifact_id = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setArtifactId($var)
    {
        GPBUtil::checkString($var, True);
        $this->artifact_id = $var;

        return $this;
    }

    /**
     * Maven `groupId` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string group_id = 4;</code>
     * @return string
     */
    public function getGroupId()
    {
        return $this->group_id;
    }

    /**
     * Maven `groupId` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string group_id = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setGroupId($var)
    {
        GPBUtil::checkString($var, True);
        $this->group_id = $var;

        return $this;
    }

    /**
     * Maven `version` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string version = 5;</code>
     * @return string
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * Maven `version` value used when uploading the artifact to Artifact
     * Registry.
     *
     * Generated from protobuf field <code>string version = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->version = $var;

        return $this;
    }

}


