<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/cloudbuild/v1/cloudbuild.proto

namespace Google\Cloud\Build\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Location of the source in any accessible Git repository.
 *
 * Generated from protobuf message <code>google.devtools.cloudbuild.v1.GitSource</code>
 */
class GitSource extends \Google\Protobuf\Internal\Message
{
    /**
     * Location of the Git repo to build.
     * This will be used as a `git remote`, see
     * https://git-scm.com/docs/git-remote.
     *
     * Generated from protobuf field <code>string url = 1;</code>
     */
    private $url = '';
    /**
     * Directory, relative to the source root, in which to run the build.
     * This must be a relative path. If a step's `dir` is specified and is an
     * absolute path, this value is ignored for that step's execution.
     *
     * Generated from protobuf field <code>string dir = 5;</code>
     */
    private $dir = '';
    /**
     * The revision to fetch from the Git repository such as a branch, a tag, a
     * commit SHA, or any Git ref.
     * Cloud Build uses `git fetch` to fetch the revision from the Git
     * repository; therefore make sure that the string you provide for `revision`
     * is parsable  by the command. For information on string values accepted by
     * `git fetch`, see
     * https://git-scm.com/docs/gitrevisions#_specifying_revisions. For
     * information on `git fetch`, see https://git-scm.com/docs/git-fetch.
     *
     * Generated from protobuf field <code>string revision = 6;</code>
     */
    private $revision = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $url
     *           Location of the Git repo to build.
     *           This will be used as a `git remote`, see
     *           https://git-scm.com/docs/git-remote.
     *     @type string $dir
     *           Directory, relative to the source root, in which to run the build.
     *           This must be a relative path. If a step's `dir` is specified and is an
     *           absolute path, this value is ignored for that step's execution.
     *     @type string $revision
     *           The revision to fetch from the Git repository such as a branch, a tag, a
     *           commit SHA, or any Git ref.
     *           Cloud Build uses `git fetch` to fetch the revision from the Git
     *           repository; therefore make sure that the string you provide for `revision`
     *           is parsable  by the command. For information on string values accepted by
     *           `git fetch`, see
     *           https://git-scm.com/docs/gitrevisions#_specifying_revisions. For
     *           information on `git fetch`, see https://git-scm.com/docs/git-fetch.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Devtools\Cloudbuild\V1\Cloudbuild::initOnce();
        parent::__construct($data);
    }

    /**
     * Location of the Git repo to build.
     * This will be used as a `git remote`, see
     * https://git-scm.com/docs/git-remote.
     *
     * Generated from protobuf field <code>string url = 1;</code>
     * @return string
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * Location of the Git repo to build.
     * This will be used as a `git remote`, see
     * https://git-scm.com/docs/git-remote.
     *
     * Generated from protobuf field <code>string url = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->url = $var;

        return $this;
    }

    /**
     * Directory, relative to the source root, in which to run the build.
     * This must be a relative path. If a step's `dir` is specified and is an
     * absolute path, this value is ignored for that step's execution.
     *
     * Generated from protobuf field <code>string dir = 5;</code>
     * @return string
     */
    public function getDir()
    {
        return $this->dir;
    }

    /**
     * Directory, relative to the source root, in which to run the build.
     * This must be a relative path. If a step's `dir` is specified and is an
     * absolute path, this value is ignored for that step's execution.
     *
     * Generated from protobuf field <code>string dir = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setDir($var)
    {
        GPBUtil::checkString($var, True);
        $this->dir = $var;

        return $this;
    }

    /**
     * The revision to fetch from the Git repository such as a branch, a tag, a
     * commit SHA, or any Git ref.
     * Cloud Build uses `git fetch` to fetch the revision from the Git
     * repository; therefore make sure that the string you provide for `revision`
     * is parsable  by the command. For information on string values accepted by
     * `git fetch`, see
     * https://git-scm.com/docs/gitrevisions#_specifying_revisions. For
     * information on `git fetch`, see https://git-scm.com/docs/git-fetch.
     *
     * Generated from protobuf field <code>string revision = 6;</code>
     * @return string
     */
    public function getRevision()
    {
        return $this->revision;
    }

    /**
     * The revision to fetch from the Git repository such as a branch, a tag, a
     * commit SHA, or any Git ref.
     * Cloud Build uses `git fetch` to fetch the revision from the Git
     * repository; therefore make sure that the string you provide for `revision`
     * is parsable  by the command. For information on string values accepted by
     * `git fetch`, see
     * https://git-scm.com/docs/gitrevisions#_specifying_revisions. For
     * information on `git fetch`, see https://git-scm.com/docs/git-fetch.
     *
     * Generated from protobuf field <code>string revision = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setRevision($var)
    {
        GPBUtil::checkString($var, True);
        $this->revision = $var;

        return $this;
    }

}

