<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/cloudbuild/v2/repositories.proto

namespace Google\Cloud\Build\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for creating a Connection
 *
 * Generated from protobuf message <code>google.devtools.cloudbuild.v2.CreateConnectionRequest</code>
 */
class CreateConnectionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Project and location where the connection will be created.
     * Format: `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Required. The Connection to create.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.Connection connection = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $connection = null;
    /**
     * Required. The ID to use for the Connection, which will become the final
     * component of the Connection's resource name. Names must be unique
     * per-project per-location. Allows alphanumeric characters and any of
     * -._~%!$&'()*+,;=&#64;.
     *
     * Generated from protobuf field <code>string connection_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $connection_id = '';

    /**
     * @param string                            $parent       Required. Project and location where the connection will be created.
     *                                                        Format: `projects/&#42;/locations/*`. Please see
     *                                                        {@see RepositoryManagerClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\Build\V2\Connection $connection   Required. The Connection to create.
     * @param string                            $connectionId Required. The ID to use for the Connection, which will become the final
     *                                                        component of the Connection's resource name. Names must be unique
     *                                                        per-project per-location. Allows alphanumeric characters and any of
     *                                                        -._~%!$&'()*+,;=&#64;.
     *
     * @return \Google\Cloud\Build\V2\CreateConnectionRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Build\V2\Connection $connection, string $connectionId): self
    {
        return (new self())
            ->setParent($parent)
            ->setConnection($connection)
            ->setConnectionId($connectionId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Project and location where the connection will be created.
     *           Format: `projects/&#42;&#47;locations/&#42;`.
     *     @type \Google\Cloud\Build\V2\Connection $connection
     *           Required. The Connection to create.
     *     @type string $connection_id
     *           Required. The ID to use for the Connection, which will become the final
     *           component of the Connection's resource name. Names must be unique
     *           per-project per-location. Allows alphanumeric characters and any of
     *           -._~%!$&'()*+,;=&#64;.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Devtools\Cloudbuild\V2\Repositories::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Project and location where the connection will be created.
     * Format: `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Project and location where the connection will be created.
     * Format: `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The Connection to create.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.Connection connection = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Build\V2\Connection|null
     */
    public function getConnection()
    {
        return $this->connection;
    }

    public function hasConnection()
    {
        return isset($this->connection);
    }

    public function clearConnection()
    {
        unset($this->connection);
    }

    /**
     * Required. The Connection to create.
     *
     * Generated from protobuf field <code>.google.devtools.cloudbuild.v2.Connection connection = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Build\V2\Connection $var
     * @return $this
     */
    public function setConnection($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Build\V2\Connection::class);
        $this->connection = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the Connection, which will become the final
     * component of the Connection's resource name. Names must be unique
     * per-project per-location. Allows alphanumeric characters and any of
     * -._~%!$&'()*+,;=&#64;.
     *
     * Generated from protobuf field <code>string connection_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getConnectionId()
    {
        return $this->connection_id;
    }

    /**
     * Required. The ID to use for the Connection, which will become the final
     * component of the Connection's resource name. Names must be unique
     * per-project per-location. Allows alphanumeric characters and any of
     * -._~%!$&'()*+,;=&#64;.
     *
     * Generated from protobuf field <code>string connection_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setConnectionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->connection_id = $var;

        return $this;
    }

}

