<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/channel/v1/common.proto

namespace Google\Cloud\Channel\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Cloud Identity information for the Cloud Channel Customer.
 *
 * Generated from protobuf message <code>google.cloud.channel.v1.CloudIdentityInfo</code>
 */
class CloudIdentityInfo extends \Google\Protobuf\Internal\Message
{
    /**
     * CustomerType indicates verification type needed for using services.
     *
     * Generated from protobuf field <code>.google.cloud.channel.v1.CloudIdentityInfo.CustomerType customer_type = 1;</code>
     */
    private $customer_type = 0;
    /**
     * Output only. The primary domain name.
     *
     * Generated from protobuf field <code>string primary_domain = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $primary_domain = '';
    /**
     * Output only. Whether the domain is verified.
     * This field is not returned for a Customer's cloud_identity_info resource.
     * Partners can use the domains.get() method of the Workspace SDK's
     * Directory API, or listen to the PRIMARY_DOMAIN_VERIFIED Pub/Sub event in
     * to track domain verification of their resolve Workspace customers.
     *
     * Generated from protobuf field <code>bool is_domain_verified = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $is_domain_verified = false;
    /**
     * The alternate email.
     *
     * Generated from protobuf field <code>string alternate_email = 6;</code>
     */
    private $alternate_email = '';
    /**
     * Phone number associated with the Cloud Identity.
     *
     * Generated from protobuf field <code>string phone_number = 7;</code>
     */
    private $phone_number = '';
    /**
     * Language code.
     *
     * Generated from protobuf field <code>string language_code = 8;</code>
     */
    private $language_code = '';
    /**
     * Output only. URI of Customer's Admin console dashboard.
     *
     * Generated from protobuf field <code>string admin_console_uri = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $admin_console_uri = '';
    /**
     * Edu information about the customer.
     *
     * Generated from protobuf field <code>.google.cloud.channel.v1.EduData edu_data = 22;</code>
     */
    private $edu_data = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $customer_type
     *           CustomerType indicates verification type needed for using services.
     *     @type string $primary_domain
     *           Output only. The primary domain name.
     *     @type bool $is_domain_verified
     *           Output only. Whether the domain is verified.
     *           This field is not returned for a Customer's cloud_identity_info resource.
     *           Partners can use the domains.get() method of the Workspace SDK's
     *           Directory API, or listen to the PRIMARY_DOMAIN_VERIFIED Pub/Sub event in
     *           to track domain verification of their resolve Workspace customers.
     *     @type string $alternate_email
     *           The alternate email.
     *     @type string $phone_number
     *           Phone number associated with the Cloud Identity.
     *     @type string $language_code
     *           Language code.
     *     @type string $admin_console_uri
     *           Output only. URI of Customer's Admin console dashboard.
     *     @type \Google\Cloud\Channel\V1\EduData $edu_data
     *           Edu information about the customer.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Channel\V1\Common::initOnce();
        parent::__construct($data);
    }

    /**
     * CustomerType indicates verification type needed for using services.
     *
     * Generated from protobuf field <code>.google.cloud.channel.v1.CloudIdentityInfo.CustomerType customer_type = 1;</code>
     * @return int
     */
    public function getCustomerType()
    {
        return $this->customer_type;
    }

    /**
     * CustomerType indicates verification type needed for using services.
     *
     * Generated from protobuf field <code>.google.cloud.channel.v1.CloudIdentityInfo.CustomerType customer_type = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setCustomerType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Channel\V1\CloudIdentityInfo\CustomerType::class);
        $this->customer_type = $var;

        return $this;
    }

    /**
     * Output only. The primary domain name.
     *
     * Generated from protobuf field <code>string primary_domain = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPrimaryDomain()
    {
        return $this->primary_domain;
    }

    /**
     * Output only. The primary domain name.
     *
     * Generated from protobuf field <code>string primary_domain = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPrimaryDomain($var)
    {
        GPBUtil::checkString($var, True);
        $this->primary_domain = $var;

        return $this;
    }

    /**
     * Output only. Whether the domain is verified.
     * This field is not returned for a Customer's cloud_identity_info resource.
     * Partners can use the domains.get() method of the Workspace SDK's
     * Directory API, or listen to the PRIMARY_DOMAIN_VERIFIED Pub/Sub event in
     * to track domain verification of their resolve Workspace customers.
     *
     * Generated from protobuf field <code>bool is_domain_verified = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getIsDomainVerified()
    {
        return $this->is_domain_verified;
    }

    /**
     * Output only. Whether the domain is verified.
     * This field is not returned for a Customer's cloud_identity_info resource.
     * Partners can use the domains.get() method of the Workspace SDK's
     * Directory API, or listen to the PRIMARY_DOMAIN_VERIFIED Pub/Sub event in
     * to track domain verification of their resolve Workspace customers.
     *
     * Generated from protobuf field <code>bool is_domain_verified = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setIsDomainVerified($var)
    {
        GPBUtil::checkBool($var);
        $this->is_domain_verified = $var;

        return $this;
    }

    /**
     * The alternate email.
     *
     * Generated from protobuf field <code>string alternate_email = 6;</code>
     * @return string
     */
    public function getAlternateEmail()
    {
        return $this->alternate_email;
    }

    /**
     * The alternate email.
     *
     * Generated from protobuf field <code>string alternate_email = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setAlternateEmail($var)
    {
        GPBUtil::checkString($var, True);
        $this->alternate_email = $var;

        return $this;
    }

    /**
     * Phone number associated with the Cloud Identity.
     *
     * Generated from protobuf field <code>string phone_number = 7;</code>
     * @return string
     */
    public function getPhoneNumber()
    {
        return $this->phone_number;
    }

    /**
     * Phone number associated with the Cloud Identity.
     *
     * Generated from protobuf field <code>string phone_number = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setPhoneNumber($var)
    {
        GPBUtil::checkString($var, True);
        $this->phone_number = $var;

        return $this;
    }

    /**
     * Language code.
     *
     * Generated from protobuf field <code>string language_code = 8;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * Language code.
     *
     * Generated from protobuf field <code>string language_code = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

    /**
     * Output only. URI of Customer's Admin console dashboard.
     *
     * Generated from protobuf field <code>string admin_console_uri = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getAdminConsoleUri()
    {
        return $this->admin_console_uri;
    }

    /**
     * Output only. URI of Customer's Admin console dashboard.
     *
     * Generated from protobuf field <code>string admin_console_uri = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setAdminConsoleUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->admin_console_uri = $var;

        return $this;
    }

    /**
     * Edu information about the customer.
     *
     * Generated from protobuf field <code>.google.cloud.channel.v1.EduData edu_data = 22;</code>
     * @return \Google\Cloud\Channel\V1\EduData|null
     */
    public function getEduData()
    {
        return $this->edu_data;
    }

    public function hasEduData()
    {
        return isset($this->edu_data);
    }

    public function clearEduData()
    {
        unset($this->edu_data);
    }

    /**
     * Edu information about the customer.
     *
     * Generated from protobuf field <code>.google.cloud.channel.v1.EduData edu_data = 22;</code>
     * @param \Google\Cloud\Channel\V1\EduData $var
     * @return $this
     */
    public function setEduData($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Channel\V1\EduData::class);
        $this->edu_data = $var;

        return $this;
    }

}

