<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/channel/v1/customers.proto

namespace Google\Cloud\Channel\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Contact information for a customer account.
 *
 * Generated from protobuf message <code>google.cloud.channel.v1.ContactInfo</code>
 */
class ContactInfo extends \Google\Protobuf\Internal\Message
{
    /**
     * The customer account contact's first name. Optional for Team customers.
     *
     * Generated from protobuf field <code>string first_name = 1;</code>
     */
    private $first_name = '';
    /**
     * The customer account contact's last name. Optional for Team customers.
     *
     * Generated from protobuf field <code>string last_name = 2;</code>
     */
    private $last_name = '';
    /**
     * Output only. The customer account contact's display name, formatted as a
     * combination of the customer's first and last name.
     *
     * Generated from protobuf field <code>string display_name = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $display_name = '';
    /**
     * The customer account's contact email. Required for entitlements that create
     * admin.google.com accounts, and serves as the customer's username for those
     * accounts. Use this email to invite Team customers.
     *
     * Generated from protobuf field <code>string email = 5;</code>
     */
    private $email = '';
    /**
     * Optional. The customer account contact's job title.
     *
     * Generated from protobuf field <code>string title = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $title = '';
    /**
     * The customer account's contact phone number.
     *
     * Generated from protobuf field <code>string phone = 7;</code>
     */
    private $phone = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $first_name
     *           The customer account contact's first name. Optional for Team customers.
     *     @type string $last_name
     *           The customer account contact's last name. Optional for Team customers.
     *     @type string $display_name
     *           Output only. The customer account contact's display name, formatted as a
     *           combination of the customer's first and last name.
     *     @type string $email
     *           The customer account's contact email. Required for entitlements that create
     *           admin.google.com accounts, and serves as the customer's username for those
     *           accounts. Use this email to invite Team customers.
     *     @type string $title
     *           Optional. The customer account contact's job title.
     *     @type string $phone
     *           The customer account's contact phone number.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Channel\V1\Customers::initOnce();
        parent::__construct($data);
    }

    /**
     * The customer account contact's first name. Optional for Team customers.
     *
     * Generated from protobuf field <code>string first_name = 1;</code>
     * @return string
     */
    public function getFirstName()
    {
        return $this->first_name;
    }

    /**
     * The customer account contact's first name. Optional for Team customers.
     *
     * Generated from protobuf field <code>string first_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setFirstName($var)
    {
        GPBUtil::checkString($var, True);
        $this->first_name = $var;

        return $this;
    }

    /**
     * The customer account contact's last name. Optional for Team customers.
     *
     * Generated from protobuf field <code>string last_name = 2;</code>
     * @return string
     */
    public function getLastName()
    {
        return $this->last_name;
    }

    /**
     * The customer account contact's last name. Optional for Team customers.
     *
     * Generated from protobuf field <code>string last_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setLastName($var)
    {
        GPBUtil::checkString($var, True);
        $this->last_name = $var;

        return $this;
    }

    /**
     * Output only. The customer account contact's display name, formatted as a
     * combination of the customer's first and last name.
     *
     * Generated from protobuf field <code>string display_name = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Output only. The customer account contact's display name, formatted as a
     * combination of the customer's first and last name.
     *
     * Generated from protobuf field <code>string display_name = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The customer account's contact email. Required for entitlements that create
     * admin.google.com accounts, and serves as the customer's username for those
     * accounts. Use this email to invite Team customers.
     *
     * Generated from protobuf field <code>string email = 5;</code>
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * The customer account's contact email. Required for entitlements that create
     * admin.google.com accounts, and serves as the customer's username for those
     * accounts. Use this email to invite Team customers.
     *
     * Generated from protobuf field <code>string email = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setEmail($var)
    {
        GPBUtil::checkString($var, True);
        $this->email = $var;

        return $this;
    }

    /**
     * Optional. The customer account contact's job title.
     *
     * Generated from protobuf field <code>string title = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * Optional. The customer account contact's job title.
     *
     * Generated from protobuf field <code>string title = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setTitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->title = $var;

        return $this;
    }

    /**
     * The customer account's contact phone number.
     *
     * Generated from protobuf field <code>string phone = 7;</code>
     * @return string
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * The customer account's contact phone number.
     *
     * Generated from protobuf field <code>string phone = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setPhone($var)
    {
        GPBUtil::checkString($var, True);
        $this->phone = $var;

        return $this;
    }

}

