<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/channel/v1/service.proto

namespace Google\Cloud\Channel\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
 *
 * Generated from protobuf message <code>google.cloud.channel.v1.ListEntitlementChangesRequest</code>
 */
class ListEntitlementChangesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the entitlement for which to list
     * entitlement changes. The `-` wildcard may be used to match entitlements
     * across a customer. Formats:
     *   * accounts/{account_id}/customers/{customer_id}/entitlements/{entitlement_id}
     *   * accounts/{account_id}/customers/{customer_id}/entitlements/-
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Optional. The maximum number of entitlement changes to return. The service
     * may return fewer than this value. If unspecified, returns at most 10
     * entitlement changes. The maximum value is 50; the server will coerce values
     * above 50.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_size = 0;
    /**
     * Optional. A page token, received from a previous
     * [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_token = '';
    /**
     * Optional. Filters applied to the list results.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $filter = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the entitlement for which to list
     *           entitlement changes. The `-` wildcard may be used to match entitlements
     *           across a customer. Formats:
     *             * accounts/{account_id}/customers/{customer_id}/entitlements/{entitlement_id}
     *             * accounts/{account_id}/customers/{customer_id}/entitlements/-
     *     @type int $page_size
     *           Optional. The maximum number of entitlement changes to return. The service
     *           may return fewer than this value. If unspecified, returns at most 10
     *           entitlement changes. The maximum value is 50; the server will coerce values
     *           above 50.
     *     @type string $page_token
     *           Optional. A page token, received from a previous
     *           [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
     *           call. Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to
     *           [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
     *           must match the call that provided the page token.
     *     @type string $filter
     *           Optional. Filters applied to the list results.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Channel\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the entitlement for which to list
     * entitlement changes. The `-` wildcard may be used to match entitlements
     * across a customer. Formats:
     *   * accounts/{account_id}/customers/{customer_id}/entitlements/{entitlement_id}
     *   * accounts/{account_id}/customers/{customer_id}/entitlements/-
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the entitlement for which to list
     * entitlement changes. The `-` wildcard may be used to match entitlements
     * across a customer. Formats:
     *   * accounts/{account_id}/customers/{customer_id}/entitlements/{entitlement_id}
     *   * accounts/{account_id}/customers/{customer_id}/entitlements/-
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of entitlement changes to return. The service
     * may return fewer than this value. If unspecified, returns at most 10
     * entitlement changes. The maximum value is 50; the server will coerce values
     * above 50.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of entitlement changes to return. The service
     * may return fewer than this value. If unspecified, returns at most 10
     * entitlement changes. The maximum value is 50; the server will coerce values
     * above 50.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous
     * [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous
     * [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [CloudChannelService.ListEntitlementChanges][google.cloud.channel.v1.CloudChannelService.ListEntitlementChanges]
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. Filters applied to the list results.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. Filters applied to the list results.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

