<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/channel/v1/service.proto

namespace Google\Cloud\Channel\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [CloudChannelService.ListTransferableSkus][google.cloud.channel.v1.CloudChannelService.ListTransferableSkus]
 *
 * Generated from protobuf message <code>google.cloud.channel.v1.ListTransferableSkusRequest</code>
 */
class ListTransferableSkusRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The reseller account's resource name.
     * Parent uses the format: accounts/{account_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $parent = '';
    /**
     * The requested page size. Server might return fewer results than requested.
     * If unspecified, returns at most 100 SKUs.
     * The maximum value is 1000; the server will coerce values above 1000.
     * Optional.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    private $page_size = 0;
    /**
     * A token for a page of results other than the first page.
     * Obtained using
     * [ListTransferableSkusResponse.next_page_token][google.cloud.channel.v1.ListTransferableSkusResponse.next_page_token]
     * of the previous
     * [CloudChannelService.ListTransferableSkus][google.cloud.channel.v1.CloudChannelService.ListTransferableSkus]
     * call. Optional.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    private $page_token = '';
    /**
     * Optional. The super admin of the resold customer generates this token to
     * authorize a reseller to access their Cloud Identity and purchase
     * entitlements on their behalf. You can omit this token after authorization.
     * See https://support.google.com/a/answer/7643790 for more details.
     *
     * Generated from protobuf field <code>string auth_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $auth_token = '';
    /**
     * The BCP-47 language code. For example, "en-US". The
     * response will localize in the corresponding language code, if specified.
     * The default value is "en-US".
     * Optional.
     *
     * Generated from protobuf field <code>string language_code = 6;</code>
     */
    private $language_code = '';
    protected $transferred_customer_identity;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $cloud_identity_id
     *           Customer's Cloud Identity ID
     *     @type string $customer_name
     *           A reseller is required to create a customer and use the resource name of
     *           the created customer here.
     *           Customer_name uses the format:
     *           accounts/{account_id}/customers/{customer_id}
     *     @type string $parent
     *           Required. The reseller account's resource name.
     *           Parent uses the format: accounts/{account_id}
     *     @type int $page_size
     *           The requested page size. Server might return fewer results than requested.
     *           If unspecified, returns at most 100 SKUs.
     *           The maximum value is 1000; the server will coerce values above 1000.
     *           Optional.
     *     @type string $page_token
     *           A token for a page of results other than the first page.
     *           Obtained using
     *           [ListTransferableSkusResponse.next_page_token][google.cloud.channel.v1.ListTransferableSkusResponse.next_page_token]
     *           of the previous
     *           [CloudChannelService.ListTransferableSkus][google.cloud.channel.v1.CloudChannelService.ListTransferableSkus]
     *           call. Optional.
     *     @type string $auth_token
     *           Optional. The super admin of the resold customer generates this token to
     *           authorize a reseller to access their Cloud Identity and purchase
     *           entitlements on their behalf. You can omit this token after authorization.
     *           See https://support.google.com/a/answer/7643790 for more details.
     *     @type string $language_code
     *           The BCP-47 language code. For example, "en-US". The
     *           response will localize in the corresponding language code, if specified.
     *           The default value is "en-US".
     *           Optional.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Channel\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Customer's Cloud Identity ID
     *
     * Generated from protobuf field <code>string cloud_identity_id = 4;</code>
     * @return string
     */
    public function getCloudIdentityId()
    {
        return $this->readOneof(4);
    }

    public function hasCloudIdentityId()
    {
        return $this->hasOneof(4);
    }

    /**
     * Customer's Cloud Identity ID
     *
     * Generated from protobuf field <code>string cloud_identity_id = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setCloudIdentityId($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(4, $var);

        return $this;
    }

    /**
     * A reseller is required to create a customer and use the resource name of
     * the created customer here.
     * Customer_name uses the format:
     * accounts/{account_id}/customers/{customer_id}
     *
     * Generated from protobuf field <code>string customer_name = 7;</code>
     * @return string
     */
    public function getCustomerName()
    {
        return $this->readOneof(7);
    }

    public function hasCustomerName()
    {
        return $this->hasOneof(7);
    }

    /**
     * A reseller is required to create a customer and use the resource name of
     * the created customer here.
     * Customer_name uses the format:
     * accounts/{account_id}/customers/{customer_id}
     *
     * Generated from protobuf field <code>string customer_name = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setCustomerName($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     * Required. The reseller account's resource name.
     * Parent uses the format: accounts/{account_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The reseller account's resource name.
     * Parent uses the format: accounts/{account_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The requested page size. Server might return fewer results than requested.
     * If unspecified, returns at most 100 SKUs.
     * The maximum value is 1000; the server will coerce values above 1000.
     * Optional.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The requested page size. Server might return fewer results than requested.
     * If unspecified, returns at most 100 SKUs.
     * The maximum value is 1000; the server will coerce values above 1000.
     * Optional.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A token for a page of results other than the first page.
     * Obtained using
     * [ListTransferableSkusResponse.next_page_token][google.cloud.channel.v1.ListTransferableSkusResponse.next_page_token]
     * of the previous
     * [CloudChannelService.ListTransferableSkus][google.cloud.channel.v1.CloudChannelService.ListTransferableSkus]
     * call. Optional.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A token for a page of results other than the first page.
     * Obtained using
     * [ListTransferableSkusResponse.next_page_token][google.cloud.channel.v1.ListTransferableSkusResponse.next_page_token]
     * of the previous
     * [CloudChannelService.ListTransferableSkus][google.cloud.channel.v1.CloudChannelService.ListTransferableSkus]
     * call. Optional.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. The super admin of the resold customer generates this token to
     * authorize a reseller to access their Cloud Identity and purchase
     * entitlements on their behalf. You can omit this token after authorization.
     * See https://support.google.com/a/answer/7643790 for more details.
     *
     * Generated from protobuf field <code>string auth_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAuthToken()
    {
        return $this->auth_token;
    }

    /**
     * Optional. The super admin of the resold customer generates this token to
     * authorize a reseller to access their Cloud Identity and purchase
     * entitlements on their behalf. You can omit this token after authorization.
     * See https://support.google.com/a/answer/7643790 for more details.
     *
     * Generated from protobuf field <code>string auth_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAuthToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->auth_token = $var;

        return $this;
    }

    /**
     * The BCP-47 language code. For example, "en-US". The
     * response will localize in the corresponding language code, if specified.
     * The default value is "en-US".
     * Optional.
     *
     * Generated from protobuf field <code>string language_code = 6;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * The BCP-47 language code. For example, "en-US". The
     * response will localize in the corresponding language code, if specified.
     * The default value is "en-US".
     * Optional.
     *
     * Generated from protobuf field <code>string language_code = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getTransferredCustomerIdentity()
    {
        return $this->whichOneof("transferred_customer_identity");
    }

}

