<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/audit/bigquery_audit_metadata.proto

namespace Google\Cloud\Audit\BigQueryAuditMetadata;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * BigQuery dataset.
 *
 * Generated from protobuf message <code>google.cloud.audit.BigQueryAuditMetadata.Dataset</code>
 */
class Dataset extends \Google\Protobuf\Internal\Message
{
    /**
     * Dataset URI.
     * Format: `projects/<project_id>/datasets/<dataset_id>`.
     *
     * Generated from protobuf field <code>string dataset_name = 1;</code>
     */
    protected $dataset_name = '';
    /**
     * User-provided metadata for the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.EntityInfo dataset_info = 7;</code>
     */
    protected $dataset_info = null;
    /**
     * Dataset creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3;</code>
     */
    protected $create_time = null;
    /**
     * Dataset metadata last update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4;</code>
     */
    protected $update_time = null;
    /**
     * The access control list for the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.BigQueryAcl acl = 5;</code>
     */
    protected $acl = null;
    /**
     * Default expiration time for tables in the dataset.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration default_table_expire_duration = 6;</code>
     */
    protected $default_table_expire_duration = null;
    /**
     * Default encryption for tables in the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.EncryptionInfo default_encryption = 8;</code>
     */
    protected $default_encryption = null;
    /**
     * Default collation for the dataset.
     *
     * Generated from protobuf field <code>string default_collation = 9;</code>
     */
    protected $default_collation = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $dataset_name
     *           Dataset URI.
     *           Format: `projects/<project_id>/datasets/<dataset_id>`.
     *     @type \Google\Cloud\Audit\BigQueryAuditMetadata\EntityInfo $dataset_info
     *           User-provided metadata for the dataset.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Dataset creation time.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Dataset metadata last update time.
     *     @type \Google\Cloud\Audit\BigQueryAuditMetadata\BigQueryAcl $acl
     *           The access control list for the dataset.
     *     @type \Google\Protobuf\Duration $default_table_expire_duration
     *           Default expiration time for tables in the dataset.
     *     @type \Google\Cloud\Audit\BigQueryAuditMetadata\EncryptionInfo $default_encryption
     *           Default encryption for tables in the dataset.
     *     @type string $default_collation
     *           Default collation for the dataset.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Audit\BigqueryAuditMetadata::initOnce();
        parent::__construct($data);
    }

    /**
     * Dataset URI.
     * Format: `projects/<project_id>/datasets/<dataset_id>`.
     *
     * Generated from protobuf field <code>string dataset_name = 1;</code>
     * @return string
     */
    public function getDatasetName()
    {
        return $this->dataset_name;
    }

    /**
     * Dataset URI.
     * Format: `projects/<project_id>/datasets/<dataset_id>`.
     *
     * Generated from protobuf field <code>string dataset_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setDatasetName($var)
    {
        GPBUtil::checkString($var, True);
        $this->dataset_name = $var;

        return $this;
    }

    /**
     * User-provided metadata for the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.EntityInfo dataset_info = 7;</code>
     * @return \Google\Cloud\Audit\BigQueryAuditMetadata\EntityInfo|null
     */
    public function getDatasetInfo()
    {
        return $this->dataset_info;
    }

    public function hasDatasetInfo()
    {
        return isset($this->dataset_info);
    }

    public function clearDatasetInfo()
    {
        unset($this->dataset_info);
    }

    /**
     * User-provided metadata for the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.EntityInfo dataset_info = 7;</code>
     * @param \Google\Cloud\Audit\BigQueryAuditMetadata\EntityInfo $var
     * @return $this
     */
    public function setDatasetInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Audit\BigQueryAuditMetadata\EntityInfo::class);
        $this->dataset_info = $var;

        return $this;
    }

    /**
     * Dataset creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Dataset creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Dataset metadata last update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Dataset metadata last update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * The access control list for the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.BigQueryAcl acl = 5;</code>
     * @return \Google\Cloud\Audit\BigQueryAuditMetadata\BigQueryAcl|null
     */
    public function getAcl()
    {
        return $this->acl;
    }

    public function hasAcl()
    {
        return isset($this->acl);
    }

    public function clearAcl()
    {
        unset($this->acl);
    }

    /**
     * The access control list for the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.BigQueryAcl acl = 5;</code>
     * @param \Google\Cloud\Audit\BigQueryAuditMetadata\BigQueryAcl $var
     * @return $this
     */
    public function setAcl($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Audit\BigQueryAuditMetadata\BigQueryAcl::class);
        $this->acl = $var;

        return $this;
    }

    /**
     * Default expiration time for tables in the dataset.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration default_table_expire_duration = 6;</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getDefaultTableExpireDuration()
    {
        return $this->default_table_expire_duration;
    }

    public function hasDefaultTableExpireDuration()
    {
        return isset($this->default_table_expire_duration);
    }

    public function clearDefaultTableExpireDuration()
    {
        unset($this->default_table_expire_duration);
    }

    /**
     * Default expiration time for tables in the dataset.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration default_table_expire_duration = 6;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setDefaultTableExpireDuration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->default_table_expire_duration = $var;

        return $this;
    }

    /**
     * Default encryption for tables in the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.EncryptionInfo default_encryption = 8;</code>
     * @return \Google\Cloud\Audit\BigQueryAuditMetadata\EncryptionInfo|null
     */
    public function getDefaultEncryption()
    {
        return $this->default_encryption;
    }

    public function hasDefaultEncryption()
    {
        return isset($this->default_encryption);
    }

    public function clearDefaultEncryption()
    {
        unset($this->default_encryption);
    }

    /**
     * Default encryption for tables in the dataset.
     *
     * Generated from protobuf field <code>.google.cloud.audit.BigQueryAuditMetadata.EncryptionInfo default_encryption = 8;</code>
     * @param \Google\Cloud\Audit\BigQueryAuditMetadata\EncryptionInfo $var
     * @return $this
     */
    public function setDefaultEncryption($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Audit\BigQueryAuditMetadata\EncryptionInfo::class);
        $this->default_encryption = $var;

        return $this;
    }

    /**
     * Default collation for the dataset.
     *
     * Generated from protobuf field <code>string default_collation = 9;</code>
     * @return string
     */
    public function getDefaultCollation()
    {
        return $this->default_collation;
    }

    /**
     * Default collation for the dataset.
     *
     * Generated from protobuf field <code>string default_collation = 9;</code>
     * @param string $var
     * @return $this
     */
    public function setDefaultCollation($var)
    {
        GPBUtil::checkString($var, True);
        $this->default_collation = $var;

        return $this;
    }

}


