<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The available logging options for the load balancer traffic served by this backend service.
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.BackendServiceLogConfig</code>
 */
class BackendServiceLogConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Denotes whether to enable logging for the load balancer traffic served by this backend service. The default value is false.
     *
     * Generated from protobuf field <code>optional bool enable = 311764355;</code>
     */
    private $enable = null;
    /**
     * This field can only be specified if logging is enabled for this backend service and "logConfig.optionalMode" was set to CUSTOM. Contains a list of optional fields you want to include in the logs. For example: serverInstance, serverGkeDetails.cluster, serverGkeDetails.pod.podNamespace
     *
     * Generated from protobuf field <code>repeated string optional_fields = 528589944;</code>
     */
    private $optional_fields;
    /**
     * This field can only be specified if logging is enabled for this backend service. Configures whether all, none or a subset of optional fields should be added to the reported logs. One of [INCLUDE_ALL_OPTIONAL, EXCLUDE_ALL_OPTIONAL, CUSTOM]. Default is EXCLUDE_ALL_OPTIONAL.
     * Check the OptionalMode enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string optional_mode = 128697122;</code>
     */
    private $optional_mode = null;
    /**
     * This field can only be specified if logging is enabled for this backend service. The value of the field must be in [0, 1]. This configures the sampling rate of requests to the load balancer where 1.0 means all logged requests are reported and 0.0 means no logged requests are reported. The default value is 1.0.
     *
     * Generated from protobuf field <code>optional float sample_rate = 153193045;</code>
     */
    private $sample_rate = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $enable
     *           Denotes whether to enable logging for the load balancer traffic served by this backend service. The default value is false.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $optional_fields
     *           This field can only be specified if logging is enabled for this backend service and "logConfig.optionalMode" was set to CUSTOM. Contains a list of optional fields you want to include in the logs. For example: serverInstance, serverGkeDetails.cluster, serverGkeDetails.pod.podNamespace
     *     @type string $optional_mode
     *           This field can only be specified if logging is enabled for this backend service. Configures whether all, none or a subset of optional fields should be added to the reported logs. One of [INCLUDE_ALL_OPTIONAL, EXCLUDE_ALL_OPTIONAL, CUSTOM]. Default is EXCLUDE_ALL_OPTIONAL.
     *           Check the OptionalMode enum for the list of possible values.
     *     @type float $sample_rate
     *           This field can only be specified if logging is enabled for this backend service. The value of the field must be in [0, 1]. This configures the sampling rate of requests to the load balancer where 1.0 means all logged requests are reported and 0.0 means no logged requests are reported. The default value is 1.0.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * Denotes whether to enable logging for the load balancer traffic served by this backend service. The default value is false.
     *
     * Generated from protobuf field <code>optional bool enable = 311764355;</code>
     * @return bool
     */
    public function getEnable()
    {
        return isset($this->enable) ? $this->enable : false;
    }

    public function hasEnable()
    {
        return isset($this->enable);
    }

    public function clearEnable()
    {
        unset($this->enable);
    }

    /**
     * Denotes whether to enable logging for the load balancer traffic served by this backend service. The default value is false.
     *
     * Generated from protobuf field <code>optional bool enable = 311764355;</code>
     * @param bool $var
     * @return $this
     */
    public function setEnable($var)
    {
        GPBUtil::checkBool($var);
        $this->enable = $var;

        return $this;
    }

    /**
     * This field can only be specified if logging is enabled for this backend service and "logConfig.optionalMode" was set to CUSTOM. Contains a list of optional fields you want to include in the logs. For example: serverInstance, serverGkeDetails.cluster, serverGkeDetails.pod.podNamespace
     *
     * Generated from protobuf field <code>repeated string optional_fields = 528589944;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getOptionalFields()
    {
        return $this->optional_fields;
    }

    /**
     * This field can only be specified if logging is enabled for this backend service and "logConfig.optionalMode" was set to CUSTOM. Contains a list of optional fields you want to include in the logs. For example: serverInstance, serverGkeDetails.cluster, serverGkeDetails.pod.podNamespace
     *
     * Generated from protobuf field <code>repeated string optional_fields = 528589944;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setOptionalFields($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->optional_fields = $arr;

        return $this;
    }

    /**
     * This field can only be specified if logging is enabled for this backend service. Configures whether all, none or a subset of optional fields should be added to the reported logs. One of [INCLUDE_ALL_OPTIONAL, EXCLUDE_ALL_OPTIONAL, CUSTOM]. Default is EXCLUDE_ALL_OPTIONAL.
     * Check the OptionalMode enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string optional_mode = 128697122;</code>
     * @return string
     */
    public function getOptionalMode()
    {
        return isset($this->optional_mode) ? $this->optional_mode : '';
    }

    public function hasOptionalMode()
    {
        return isset($this->optional_mode);
    }

    public function clearOptionalMode()
    {
        unset($this->optional_mode);
    }

    /**
     * This field can only be specified if logging is enabled for this backend service. Configures whether all, none or a subset of optional fields should be added to the reported logs. One of [INCLUDE_ALL_OPTIONAL, EXCLUDE_ALL_OPTIONAL, CUSTOM]. Default is EXCLUDE_ALL_OPTIONAL.
     * Check the OptionalMode enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string optional_mode = 128697122;</code>
     * @param string $var
     * @return $this
     */
    public function setOptionalMode($var)
    {
        GPBUtil::checkString($var, True);
        $this->optional_mode = $var;

        return $this;
    }

    /**
     * This field can only be specified if logging is enabled for this backend service. The value of the field must be in [0, 1]. This configures the sampling rate of requests to the load balancer where 1.0 means all logged requests are reported and 0.0 means no logged requests are reported. The default value is 1.0.
     *
     * Generated from protobuf field <code>optional float sample_rate = 153193045;</code>
     * @return float
     */
    public function getSampleRate()
    {
        return isset($this->sample_rate) ? $this->sample_rate : 0.0;
    }

    public function hasSampleRate()
    {
        return isset($this->sample_rate);
    }

    public function clearSampleRate()
    {
        unset($this->sample_rate);
    }

    /**
     * This field can only be specified if logging is enabled for this backend service. The value of the field must be in [0, 1]. This configures the sampling rate of requests to the load balancer where 1.0 means all logged requests are reported and 0.0 means no logged requests are reported. The default value is 1.0.
     *
     * Generated from protobuf field <code>optional float sample_rate = 153193045;</code>
     * @param float $var
     * @return $this
     */
    public function setSampleRate($var)
    {
        GPBUtil::checkFloat($var);
        $this->sample_rate = $var;

        return $this;
    }

}

