<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/confidentialcomputing/v1/service.proto

namespace Google\Cloud\ConfidentialComputing\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A request for an OIDC token, providing all the necessary information needed
 * for this service to verify the plaform state of the requestor.
 *
 * Generated from protobuf message <code>google.cloud.confidentialcomputing.v1.VerifyAttestationRequest</code>
 */
class VerifyAttestationRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the Challenge whose nonce was used to generate the
     * attestation, in the format `projects/&#42;&#47;locations/&#42;&#47;challenges/&#42;`. The
     * provided Challenge will be consumed, and cannot be used again.
     *
     * Generated from protobuf field <code>string challenge = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $challenge = '';
    /**
     * Optional. Credentials used to populate the "emails" claim in the
     * claims_token.
     *
     * Generated from protobuf field <code>.google.cloud.confidentialcomputing.v1.GcpCredentials gcp_credentials = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $gcp_credentials = null;
    /**
     * Required. The TPM-specific data provided by the attesting platform, used to
     * populate any of the claims regarding platform state.
     *
     * Generated from protobuf field <code>.google.cloud.confidentialcomputing.v1.TpmAttestation tpm_attestation = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $tpm_attestation = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $challenge
     *           Required. The name of the Challenge whose nonce was used to generate the
     *           attestation, in the format `projects/&#42;&#47;locations/&#42;&#47;challenges/&#42;`. The
     *           provided Challenge will be consumed, and cannot be used again.
     *     @type \Google\Cloud\ConfidentialComputing\V1\GcpCredentials $gcp_credentials
     *           Optional. Credentials used to populate the "emails" claim in the
     *           claims_token.
     *     @type \Google\Cloud\ConfidentialComputing\V1\TpmAttestation $tpm_attestation
     *           Required. The TPM-specific data provided by the attesting platform, used to
     *           populate any of the claims regarding platform state.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Confidentialcomputing\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the Challenge whose nonce was used to generate the
     * attestation, in the format `projects/&#42;&#47;locations/&#42;&#47;challenges/&#42;`. The
     * provided Challenge will be consumed, and cannot be used again.
     *
     * Generated from protobuf field <code>string challenge = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getChallenge()
    {
        return $this->challenge;
    }

    /**
     * Required. The name of the Challenge whose nonce was used to generate the
     * attestation, in the format `projects/&#42;&#47;locations/&#42;&#47;challenges/&#42;`. The
     * provided Challenge will be consumed, and cannot be used again.
     *
     * Generated from protobuf field <code>string challenge = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setChallenge($var)
    {
        GPBUtil::checkString($var, True);
        $this->challenge = $var;

        return $this;
    }

    /**
     * Optional. Credentials used to populate the "emails" claim in the
     * claims_token.
     *
     * Generated from protobuf field <code>.google.cloud.confidentialcomputing.v1.GcpCredentials gcp_credentials = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\ConfidentialComputing\V1\GcpCredentials|null
     */
    public function getGcpCredentials()
    {
        return $this->gcp_credentials;
    }

    public function hasGcpCredentials()
    {
        return isset($this->gcp_credentials);
    }

    public function clearGcpCredentials()
    {
        unset($this->gcp_credentials);
    }

    /**
     * Optional. Credentials used to populate the "emails" claim in the
     * claims_token.
     *
     * Generated from protobuf field <code>.google.cloud.confidentialcomputing.v1.GcpCredentials gcp_credentials = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\ConfidentialComputing\V1\GcpCredentials $var
     * @return $this
     */
    public function setGcpCredentials($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ConfidentialComputing\V1\GcpCredentials::class);
        $this->gcp_credentials = $var;

        return $this;
    }

    /**
     * Required. The TPM-specific data provided by the attesting platform, used to
     * populate any of the claims regarding platform state.
     *
     * Generated from protobuf field <code>.google.cloud.confidentialcomputing.v1.TpmAttestation tpm_attestation = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ConfidentialComputing\V1\TpmAttestation|null
     */
    public function getTpmAttestation()
    {
        return $this->tpm_attestation;
    }

    public function hasTpmAttestation()
    {
        return isset($this->tpm_attestation);
    }

    public function clearTpmAttestation()
    {
        unset($this->tpm_attestation);
    }

    /**
     * Required. The TPM-specific data provided by the attesting platform, used to
     * populate any of the claims regarding platform state.
     *
     * Generated from protobuf field <code>.google.cloud.confidentialcomputing.v1.TpmAttestation tpm_attestation = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ConfidentialComputing\V1\TpmAttestation $var
     * @return $this
     */
    public function setTpmAttestation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ConfidentialComputing\V1\TpmAttestation::class);
        $this->tpm_attestation = $var;

        return $this;
    }

}

