<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/container/v1/cluster_service.proto

namespace Google\Cloud\Container\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * ListUsableSubnetworksRequest requests the list of usable subnetworks
 * available to a user for creating clusters.
 *
 * Generated from protobuf message <code>google.container.v1.ListUsableSubnetworksRequest</code>
 */
class ListUsableSubnetworksRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * The parent project where subnetworks are usable.
     * Specified in the format `projects/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     */
    private $parent = '';
    /**
     * Filtering currently only supports equality on the networkProjectId and must
     * be in the form: "networkProjectId=[PROJECTID]", where `networkProjectId`
     * is the project which owns the listed subnetworks. This defaults to the
     * parent project ID.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     */
    private $filter = '';
    /**
     * The max number of results per page that should be returned. If the number
     * of available results is larger than `page_size`, a `next_page_token` is
     * returned which can be used to get the next page of results in subsequent
     * requests. Acceptable values are 0 to 500, inclusive. (Default: 500)
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    private $page_size = 0;
    /**
     * Specifies a page token to use. Set this to the nextPageToken returned by
     * previous list requests to get the next page of results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    private $page_token = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           The parent project where subnetworks are usable.
     *           Specified in the format `projects/&#42;`.
     *     @type string $filter
     *           Filtering currently only supports equality on the networkProjectId and must
     *           be in the form: "networkProjectId=[PROJECTID]", where `networkProjectId`
     *           is the project which owns the listed subnetworks. This defaults to the
     *           parent project ID.
     *     @type int $page_size
     *           The max number of results per page that should be returned. If the number
     *           of available results is larger than `page_size`, a `next_page_token` is
     *           returned which can be used to get the next page of results in subsequent
     *           requests. Acceptable values are 0 to 500, inclusive. (Default: 500)
     *     @type string $page_token
     *           Specifies a page token to use. Set this to the nextPageToken returned by
     *           previous list requests to get the next page of results.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Container\V1\ClusterService::initOnce();
        parent::__construct($data);
    }

    /**
     * The parent project where subnetworks are usable.
     * Specified in the format `projects/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * The parent project where subnetworks are usable.
     * Specified in the format `projects/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Filtering currently only supports equality on the networkProjectId and must
     * be in the form: "networkProjectId=[PROJECTID]", where `networkProjectId`
     * is the project which owns the listed subnetworks. This defaults to the
     * parent project ID.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Filtering currently only supports equality on the networkProjectId and must
     * be in the form: "networkProjectId=[PROJECTID]", where `networkProjectId`
     * is the project which owns the listed subnetworks. This defaults to the
     * parent project ID.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * The max number of results per page that should be returned. If the number
     * of available results is larger than `page_size`, a `next_page_token` is
     * returned which can be used to get the next page of results in subsequent
     * requests. Acceptable values are 0 to 500, inclusive. (Default: 500)
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The max number of results per page that should be returned. If the number
     * of available results is larger than `page_size`, a `next_page_token` is
     * returned which can be used to get the next page of results in subsequent
     * requests. Acceptable values are 0 to 500, inclusive. (Default: 500)
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Specifies a page token to use. Set this to the nextPageToken returned by
     * previous list requests to get the next page of results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Specifies a page token to use. Set this to the nextPageToken returned by
     * previous list requests to get the next page of results.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

