<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datalabeling/v1beta1/data_labeling_service.proto

namespace Google\Cloud\DataLabeling\V1beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for ExportData API.
 *
 * Generated from protobuf message <code>google.cloud.datalabeling.v1beta1.ExportDataRequest</code>
 */
class ExportDataRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Dataset resource name, format:
     * projects/{project_id}/datasets/{dataset_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $name = '';
    /**
     * Required. Annotated dataset resource name. DataItem in
     * Dataset and their annotations in specified annotated dataset will be
     * exported. It's in format of
     * projects/{project_id}/datasets/{dataset_id}/annotatedDatasets/
     * {annotated_dataset_id}
     *
     * Generated from protobuf field <code>string annotated_dataset = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $annotated_dataset = '';
    /**
     * Optional. Filter is not supported at this moment.
     *
     * Generated from protobuf field <code>string filter = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $filter = '';
    /**
     * Required. Specify the output destination.
     *
     * Generated from protobuf field <code>.google.cloud.datalabeling.v1beta1.OutputConfig output_config = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $output_config = null;
    /**
     * Email of the user who started the export task and should be notified by
     * email. If empty no notification will be sent.
     *
     * Generated from protobuf field <code>string user_email_address = 5;</code>
     */
    private $user_email_address = '';

    /**
     * @param string                                          $name             Required. Dataset resource name, format:
     *                                                                          projects/{project_id}/datasets/{dataset_id}
     *                                                                          Please see {@see DataLabelingServiceClient::datasetName()} for help formatting this field.
     * @param string                                          $annotatedDataset Required. Annotated dataset resource name. DataItem in
     *                                                                          Dataset and their annotations in specified annotated dataset will be
     *                                                                          exported. It's in format of
     *                                                                          projects/{project_id}/datasets/{dataset_id}/annotatedDatasets/
     *                                                                          {annotated_dataset_id}
     *                                                                          Please see {@see DataLabelingServiceClient::annotatedDatasetName()} for help formatting this field.
     * @param string                                          $filter           Optional. Filter is not supported at this moment.
     * @param \Google\Cloud\DataLabeling\V1beta1\OutputConfig $outputConfig     Required. Specify the output destination.
     *
     * @return \Google\Cloud\DataLabeling\V1beta1\ExportDataRequest
     *
     * @experimental
     */
    public static function build(string $name, string $annotatedDataset, string $filter, \Google\Cloud\DataLabeling\V1beta1\OutputConfig $outputConfig): self
    {
        return (new self())
            ->setName($name)
            ->setAnnotatedDataset($annotatedDataset)
            ->setFilter($filter)
            ->setOutputConfig($outputConfig);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Dataset resource name, format:
     *           projects/{project_id}/datasets/{dataset_id}
     *     @type string $annotated_dataset
     *           Required. Annotated dataset resource name. DataItem in
     *           Dataset and their annotations in specified annotated dataset will be
     *           exported. It's in format of
     *           projects/{project_id}/datasets/{dataset_id}/annotatedDatasets/
     *           {annotated_dataset_id}
     *     @type string $filter
     *           Optional. Filter is not supported at this moment.
     *     @type \Google\Cloud\DataLabeling\V1beta1\OutputConfig $output_config
     *           Required. Specify the output destination.
     *     @type string $user_email_address
     *           Email of the user who started the export task and should be notified by
     *           email. If empty no notification will be sent.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datalabeling\V1Beta1\DataLabelingService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Dataset resource name, format:
     * projects/{project_id}/datasets/{dataset_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Dataset resource name, format:
     * projects/{project_id}/datasets/{dataset_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. Annotated dataset resource name. DataItem in
     * Dataset and their annotations in specified annotated dataset will be
     * exported. It's in format of
     * projects/{project_id}/datasets/{dataset_id}/annotatedDatasets/
     * {annotated_dataset_id}
     *
     * Generated from protobuf field <code>string annotated_dataset = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getAnnotatedDataset()
    {
        return $this->annotated_dataset;
    }

    /**
     * Required. Annotated dataset resource name. DataItem in
     * Dataset and their annotations in specified annotated dataset will be
     * exported. It's in format of
     * projects/{project_id}/datasets/{dataset_id}/annotatedDatasets/
     * {annotated_dataset_id}
     *
     * Generated from protobuf field <code>string annotated_dataset = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setAnnotatedDataset($var)
    {
        GPBUtil::checkString($var, True);
        $this->annotated_dataset = $var;

        return $this;
    }

    /**
     * Optional. Filter is not supported at this moment.
     *
     * Generated from protobuf field <code>string filter = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. Filter is not supported at this moment.
     *
     * Generated from protobuf field <code>string filter = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Required. Specify the output destination.
     *
     * Generated from protobuf field <code>.google.cloud.datalabeling.v1beta1.OutputConfig output_config = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\DataLabeling\V1beta1\OutputConfig|null
     */
    public function getOutputConfig()
    {
        return $this->output_config;
    }

    public function hasOutputConfig()
    {
        return isset($this->output_config);
    }

    public function clearOutputConfig()
    {
        unset($this->output_config);
    }

    /**
     * Required. Specify the output destination.
     *
     * Generated from protobuf field <code>.google.cloud.datalabeling.v1beta1.OutputConfig output_config = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\DataLabeling\V1beta1\OutputConfig $var
     * @return $this
     */
    public function setOutputConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DataLabeling\V1beta1\OutputConfig::class);
        $this->output_config = $var;

        return $this;
    }

    /**
     * Email of the user who started the export task and should be notified by
     * email. If empty no notification will be sent.
     *
     * Generated from protobuf field <code>string user_email_address = 5;</code>
     * @return string
     */
    public function getUserEmailAddress()
    {
        return $this->user_email_address;
    }

    /**
     * Email of the user who started the export task and should be notified by
     * email. If empty no notification will be sent.
     *
     * Generated from protobuf field <code>string user_email_address = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setUserEmailAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->user_email_address = $var;

        return $this;
    }

}

