<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datalabeling/v1beta1/data_labeling_service.proto

namespace Google\Cloud\DataLabeling\V1beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for ListEvaluationJobs.
 *
 * Generated from protobuf message <code>google.cloud.datalabeling.v1beta1.ListEvaluationJobsRequest</code>
 */
class ListEvaluationJobsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Evaluation job resource parent. Format:
     * "projects/<var>{project_id}</var>"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Optional. You can filter the jobs to list by model_id (also known as
     * model_name, as described in
     * [EvaluationJob.modelVersion][google.cloud.datalabeling.v1beta1.EvaluationJob.model_version]) or by
     * evaluation job state (as described in [EvaluationJob.state][google.cloud.datalabeling.v1beta1.EvaluationJob.state]). To filter
     * by both criteria, use the `AND` operator or the `OR` operator. For example,
     * you can use the following string for your filter:
     * "evaluation<span>_</span>job.model_id = <var>{model_name}</var> AND
     * evaluation<span>_</span>job.state = <var>{evaluation_job_state}</var>"
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $filter = '';
    /**
     * Optional. Requested page size. Server may return fewer results than
     * requested. Default value is 100.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_size = 0;
    /**
     * Optional. A token identifying a page of results for the server to return.
     * Typically obtained by the
     * [nextPageToken][google.cloud.datalabeling.v1beta1.ListEvaluationJobsResponse.next_page_token] in the response
     * to the previous request. The request returns the first page if this is
     * empty.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_token = '';

    /**
     * @param string $parent Required. Evaluation job resource parent. Format:
     *                       "projects/<var>{project_id}</var>"
     *                       Please see {@see DataLabelingServiceClient::projectName()} for help formatting this field.
     * @param string $filter Optional. You can filter the jobs to list by model_id (also known as
     *                       model_name, as described in
     *                       [EvaluationJob.modelVersion][google.cloud.datalabeling.v1beta1.EvaluationJob.model_version]) or by
     *                       evaluation job state (as described in [EvaluationJob.state][google.cloud.datalabeling.v1beta1.EvaluationJob.state]). To filter
     *                       by both criteria, use the `AND` operator or the `OR` operator. For example,
     *                       you can use the following string for your filter:
     *                       "evaluation<span>_</span>job.model_id = <var>{model_name}</var> AND
     *                       evaluation<span>_</span>job.state = <var>{evaluation_job_state}</var>"
     *
     * @return \Google\Cloud\DataLabeling\V1beta1\ListEvaluationJobsRequest
     *
     * @experimental
     */
    public static function build(string $parent, string $filter): self
    {
        return (new self())
            ->setParent($parent)
            ->setFilter($filter);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Evaluation job resource parent. Format:
     *           "projects/<var>{project_id}</var>"
     *     @type string $filter
     *           Optional. You can filter the jobs to list by model_id (also known as
     *           model_name, as described in
     *           [EvaluationJob.modelVersion][google.cloud.datalabeling.v1beta1.EvaluationJob.model_version]) or by
     *           evaluation job state (as described in [EvaluationJob.state][google.cloud.datalabeling.v1beta1.EvaluationJob.state]). To filter
     *           by both criteria, use the `AND` operator or the `OR` operator. For example,
     *           you can use the following string for your filter:
     *           "evaluation<span>_</span>job.model_id = <var>{model_name}</var> AND
     *           evaluation<span>_</span>job.state = <var>{evaluation_job_state}</var>"
     *     @type int $page_size
     *           Optional. Requested page size. Server may return fewer results than
     *           requested. Default value is 100.
     *     @type string $page_token
     *           Optional. A token identifying a page of results for the server to return.
     *           Typically obtained by the
     *           [nextPageToken][google.cloud.datalabeling.v1beta1.ListEvaluationJobsResponse.next_page_token] in the response
     *           to the previous request. The request returns the first page if this is
     *           empty.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datalabeling\V1Beta1\DataLabelingService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Evaluation job resource parent. Format:
     * "projects/<var>{project_id}</var>"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Evaluation job resource parent. Format:
     * "projects/<var>{project_id}</var>"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. You can filter the jobs to list by model_id (also known as
     * model_name, as described in
     * [EvaluationJob.modelVersion][google.cloud.datalabeling.v1beta1.EvaluationJob.model_version]) or by
     * evaluation job state (as described in [EvaluationJob.state][google.cloud.datalabeling.v1beta1.EvaluationJob.state]). To filter
     * by both criteria, use the `AND` operator or the `OR` operator. For example,
     * you can use the following string for your filter:
     * "evaluation<span>_</span>job.model_id = <var>{model_name}</var> AND
     * evaluation<span>_</span>job.state = <var>{evaluation_job_state}</var>"
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. You can filter the jobs to list by model_id (also known as
     * model_name, as described in
     * [EvaluationJob.modelVersion][google.cloud.datalabeling.v1beta1.EvaluationJob.model_version]) or by
     * evaluation job state (as described in [EvaluationJob.state][google.cloud.datalabeling.v1beta1.EvaluationJob.state]). To filter
     * by both criteria, use the `AND` operator or the `OR` operator. For example,
     * you can use the following string for your filter:
     * "evaluation<span>_</span>job.model_id = <var>{model_name}</var> AND
     * evaluation<span>_</span>job.state = <var>{evaluation_job_state}</var>"
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. Requested page size. Server may return fewer results than
     * requested. Default value is 100.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Requested page size. Server may return fewer results than
     * requested. Default value is 100.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A token identifying a page of results for the server to return.
     * Typically obtained by the
     * [nextPageToken][google.cloud.datalabeling.v1beta1.ListEvaluationJobsResponse.next_page_token] in the response
     * to the previous request. The request returns the first page if this is
     * empty.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A token identifying a page of results for the server to return.
     * Typically obtained by the
     * [nextPageToken][google.cloud.datalabeling.v1beta1.ListEvaluationJobsResponse.next_page_token] in the response
     * to the previous request. The request returns the first page if this is
     * empty.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

