<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/dataflow/v1beta3/jobs.proto

namespace Google\Cloud\Dataflow\V1beta3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to list Cloud Dataflow jobs.
 *
 * Generated from protobuf message <code>google.dataflow.v1beta3.ListJobsRequest</code>
 */
class ListJobsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * The kind of filter to use.
     *
     * Generated from protobuf field <code>.google.dataflow.v1beta3.ListJobsRequest.Filter filter = 5;</code>
     */
    private $filter = 0;
    /**
     * The project which owns the jobs.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     */
    private $project_id = '';
    /**
     * Deprecated. ListJobs always returns summaries now.
     * Use GetJob for other JobViews.
     *
     * Generated from protobuf field <code>.google.dataflow.v1beta3.JobView view = 2 [deprecated = true];</code>
     * @deprecated
     */
    protected $view = 0;
    /**
     * If there are many jobs, limit response to at most this many.
     * The actual number of jobs returned will be the lesser of max_responses
     * and an unspecified server-defined limit.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    private $page_size = 0;
    /**
     * Set this to the 'next_page_token' field of a previous response
     * to request additional results in a long list.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    private $page_token = '';
    /**
     * The [regional endpoint]
     * (https://cloud.google.com/dataflow/docs/concepts/regional-endpoints) that
     * contains this job.
     *
     * Generated from protobuf field <code>string location = 17;</code>
     */
    private $location = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $filter
     *           The kind of filter to use.
     *     @type string $project_id
     *           The project which owns the jobs.
     *     @type int $view
     *           Deprecated. ListJobs always returns summaries now.
     *           Use GetJob for other JobViews.
     *     @type int $page_size
     *           If there are many jobs, limit response to at most this many.
     *           The actual number of jobs returned will be the lesser of max_responses
     *           and an unspecified server-defined limit.
     *     @type string $page_token
     *           Set this to the 'next_page_token' field of a previous response
     *           to request additional results in a long list.
     *     @type string $location
     *           The [regional endpoint]
     *           (https://cloud.google.com/dataflow/docs/concepts/regional-endpoints) that
     *           contains this job.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Dataflow\V1Beta3\Jobs::initOnce();
        parent::__construct($data);
    }

    /**
     * The kind of filter to use.
     *
     * Generated from protobuf field <code>.google.dataflow.v1beta3.ListJobsRequest.Filter filter = 5;</code>
     * @return int
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * The kind of filter to use.
     *
     * Generated from protobuf field <code>.google.dataflow.v1beta3.ListJobsRequest.Filter filter = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dataflow\V1beta3\ListJobsRequest\Filter::class);
        $this->filter = $var;

        return $this;
    }

    /**
     * The project which owns the jobs.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @return string
     */
    public function getProjectId()
    {
        return $this->project_id;
    }

    /**
     * The project which owns the jobs.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_id = $var;

        return $this;
    }

    /**
     * Deprecated. ListJobs always returns summaries now.
     * Use GetJob for other JobViews.
     *
     * Generated from protobuf field <code>.google.dataflow.v1beta3.JobView view = 2 [deprecated = true];</code>
     * @return int
     * @deprecated
     */
    public function getView()
    {
        @trigger_error('view is deprecated.', E_USER_DEPRECATED);
        return $this->view;
    }

    /**
     * Deprecated. ListJobs always returns summaries now.
     * Use GetJob for other JobViews.
     *
     * Generated from protobuf field <code>.google.dataflow.v1beta3.JobView view = 2 [deprecated = true];</code>
     * @param int $var
     * @return $this
     * @deprecated
     */
    public function setView($var)
    {
        @trigger_error('view is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkEnum($var, \Google\Cloud\Dataflow\V1beta3\JobView::class);
        $this->view = $var;

        return $this;
    }

    /**
     * If there are many jobs, limit response to at most this many.
     * The actual number of jobs returned will be the lesser of max_responses
     * and an unspecified server-defined limit.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * If there are many jobs, limit response to at most this many.
     * The actual number of jobs returned will be the lesser of max_responses
     * and an unspecified server-defined limit.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Set this to the 'next_page_token' field of a previous response
     * to request additional results in a long list.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Set this to the 'next_page_token' field of a previous response
     * to request additional results in a long list.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * The [regional endpoint]
     * (https://cloud.google.com/dataflow/docs/concepts/regional-endpoints) that
     * contains this job.
     *
     * Generated from protobuf field <code>string location = 17;</code>
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * The [regional endpoint]
     * (https://cloud.google.com/dataflow/docs/concepts/regional-endpoints) that
     * contains this job.
     *
     * Generated from protobuf field <code>string location = 17;</code>
     * @param string $var
     * @return $this
     */
    public function setLocation($var)
    {
        GPBUtil::checkString($var, True);
        $this->location = $var;

        return $this;
    }

}

