<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/deploy/v1/cloud_deploy.proto

namespace Google\Cloud\Deploy\V1\CustomCanaryDeployment;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * PhaseConfig represents the configuration for a phase in the custom
 * canary deployment.
 *
 * Generated from protobuf message <code>google.cloud.deploy.v1.CustomCanaryDeployment.PhaseConfig</code>
 */
class PhaseConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The ID to assign to the `Rollout` phase.
     * This value must consist of lower-case letters, numbers, and hyphens,
     * start with a letter and end with a letter or a number, and have a max
     * length of 63 characters. In other words, it must match the following
     * regex: `^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$`.
     *
     * Generated from protobuf field <code>string phase_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $phase_id = '';
    /**
     * Required. Percentage deployment for the phase.
     *
     * Generated from protobuf field <code>int32 percentage = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $percentage = 0;
    /**
     * Skaffold profiles to use when rendering the manifest for this phase.
     * These are in addition to the profiles list specified in the
     * `DeliveryPipeline` stage.
     *
     * Generated from protobuf field <code>repeated string profiles = 3;</code>
     */
    private $profiles;
    /**
     * Whether to run verify tests after the deployment.
     *
     * Generated from protobuf field <code>bool verify = 4;</code>
     */
    private $verify = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $phase_id
     *           Required. The ID to assign to the `Rollout` phase.
     *           This value must consist of lower-case letters, numbers, and hyphens,
     *           start with a letter and end with a letter or a number, and have a max
     *           length of 63 characters. In other words, it must match the following
     *           regex: `^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$`.
     *     @type int $percentage
     *           Required. Percentage deployment for the phase.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $profiles
     *           Skaffold profiles to use when rendering the manifest for this phase.
     *           These are in addition to the profiles list specified in the
     *           `DeliveryPipeline` stage.
     *     @type bool $verify
     *           Whether to run verify tests after the deployment.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Deploy\V1\CloudDeploy::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The ID to assign to the `Rollout` phase.
     * This value must consist of lower-case letters, numbers, and hyphens,
     * start with a letter and end with a letter or a number, and have a max
     * length of 63 characters. In other words, it must match the following
     * regex: `^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$`.
     *
     * Generated from protobuf field <code>string phase_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getPhaseId()
    {
        return $this->phase_id;
    }

    /**
     * Required. The ID to assign to the `Rollout` phase.
     * This value must consist of lower-case letters, numbers, and hyphens,
     * start with a letter and end with a letter or a number, and have a max
     * length of 63 characters. In other words, it must match the following
     * regex: `^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$`.
     *
     * Generated from protobuf field <code>string phase_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setPhaseId($var)
    {
        GPBUtil::checkString($var, True);
        $this->phase_id = $var;

        return $this;
    }

    /**
     * Required. Percentage deployment for the phase.
     *
     * Generated from protobuf field <code>int32 percentage = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getPercentage()
    {
        return $this->percentage;
    }

    /**
     * Required. Percentage deployment for the phase.
     *
     * Generated from protobuf field <code>int32 percentage = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setPercentage($var)
    {
        GPBUtil::checkInt32($var);
        $this->percentage = $var;

        return $this;
    }

    /**
     * Skaffold profiles to use when rendering the manifest for this phase.
     * These are in addition to the profiles list specified in the
     * `DeliveryPipeline` stage.
     *
     * Generated from protobuf field <code>repeated string profiles = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getProfiles()
    {
        return $this->profiles;
    }

    /**
     * Skaffold profiles to use when rendering the manifest for this phase.
     * These are in addition to the profiles list specified in the
     * `DeliveryPipeline` stage.
     *
     * Generated from protobuf field <code>repeated string profiles = 3;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setProfiles($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->profiles = $arr;

        return $this;
    }

    /**
     * Whether to run verify tests after the deployment.
     *
     * Generated from protobuf field <code>bool verify = 4;</code>
     * @return bool
     */
    public function getVerify()
    {
        return $this->verify;
    }

    /**
     * Whether to run verify tests after the deployment.
     *
     * Generated from protobuf field <code>bool verify = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setVerify($var)
    {
        GPBUtil::checkBool($var);
        $this->verify = $var;

        return $this;
    }

}


