<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/v2/conversation_profile.proto

namespace Google\Cloud\Dialogflow\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Metadata for a [ConversationProfile.ClearSuggestionFeatureConfig][]
 * operation.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.v2.ClearSuggestionFeatureConfigOperationMetadata</code>
 */
class ClearSuggestionFeatureConfigOperationMetadata extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name of the conversation profile. Format:
     * `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`
     *
     * Generated from protobuf field <code>string conversation_profile = 1;</code>
     */
    private $conversation_profile = '';
    /**
     * Required. The participant role to remove the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $participant_role = 0;
    /**
     * Required. The type of the suggestion feature to remove.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature.Type suggestion_feature_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $suggestion_feature_type = 0;
    /**
     * Timestamp whe the request was created. The time is measured on server side.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 4;</code>
     */
    private $create_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $conversation_profile
     *           The resource name of the conversation profile. Format:
     *           `projects/<Project ID>/locations/<Location
     *           ID>/conversationProfiles/<Conversation Profile ID>`
     *     @type int $participant_role
     *           Required. The participant role to remove the suggestion feature
     *           config. Only HUMAN_AGENT or END_USER can be used.
     *     @type int $suggestion_feature_type
     *           Required. The type of the suggestion feature to remove.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Timestamp whe the request was created. The time is measured on server side.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\V2\ConversationProfile::initOnce();
        parent::__construct($data);
    }

    /**
     * The resource name of the conversation profile. Format:
     * `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`
     *
     * Generated from protobuf field <code>string conversation_profile = 1;</code>
     * @return string
     */
    public function getConversationProfile()
    {
        return $this->conversation_profile;
    }

    /**
     * The resource name of the conversation profile. Format:
     * `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`
     *
     * Generated from protobuf field <code>string conversation_profile = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setConversationProfile($var)
    {
        GPBUtil::checkString($var, True);
        $this->conversation_profile = $var;

        return $this;
    }

    /**
     * Required. The participant role to remove the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getParticipantRole()
    {
        return $this->participant_role;
    }

    /**
     * Required. The participant role to remove the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setParticipantRole($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\V2\Participant\Role::class);
        $this->participant_role = $var;

        return $this;
    }

    /**
     * Required. The type of the suggestion feature to remove.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature.Type suggestion_feature_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getSuggestionFeatureType()
    {
        return $this->suggestion_feature_type;
    }

    /**
     * Required. The type of the suggestion feature to remove.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature.Type suggestion_feature_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setSuggestionFeatureType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\V2\SuggestionFeature\Type::class);
        $this->suggestion_feature_type = $var;

        return $this;
    }

    /**
     * Timestamp whe the request was created. The time is measured on server side.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 4;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Timestamp whe the request was created. The time is measured on server side.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 4;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

}

