<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/dlp.proto

namespace Google\Cloud\Dlp\V2\Action;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Publish findings of a DlpJob to Data Catalog. In Data Catalog, tag
 * templates are applied to the resource that Cloud DLP scanned. Data
 * Catalog tag templates are stored in the same project and region where the
 * BigQuery table exists. For Cloud DLP to create and apply the tag template,
 * the Cloud DLP service agent must have the
 * `roles/datacatalog.tagTemplateOwner` permission on the project. The tag
 * template contains fields summarizing the results of the DlpJob. Any field
 * values previously written by another DlpJob are deleted. [InfoType naming
 * patterns][google.privacy.dlp.v2.InfoType] are strictly enforced when using
 * this feature.
 * Findings are persisted in Data Catalog storage and are governed by
 * service-specific policies for Data Catalog. For more information, see
 * [Service Specific Terms](https://cloud.google.com/terms/service-terms).
 * Only a single instance of this action can be specified. This action is
 * allowed only if all resources being scanned are BigQuery tables.
 * Compatible with: Inspect
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.Action.PublishFindingsToCloudDataCatalog</code>
 */
class PublishFindingsToCloudDataCatalog extends \Google\Protobuf\Internal\Message
{

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Dlp::initOnce();
        parent::__construct($data);
    }

}

// Adding a class alias for backwards compatibility with the previous class name.
class_alias(PublishFindingsToCloudDataCatalog::class, \Google\Cloud\Dlp\V2\Action_PublishFindingsToCloudDataCatalog::class);

