<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/eventarc/v1/trigger.proto

namespace Google\Cloud\Eventarc\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a GKE destination.
 *
 * Generated from protobuf message <code>google.cloud.eventarc.v1.GKE</code>
 */
class GKE extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the cluster the GKE service is running in. The cluster must be
     * running in the same project as the trigger being created.
     *
     * Generated from protobuf field <code>string cluster = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $cluster = '';
    /**
     * Required. The name of the Google Compute Engine in which the cluster resides, which
     * can either be compute zone (for example, us-central1-a) for the zonal
     * clusters or region (for example, us-central1) for regional clusters.
     *
     * Generated from protobuf field <code>string location = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $location = '';
    /**
     * Required. The namespace the GKE service is running in.
     *
     * Generated from protobuf field <code>string namespace = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $namespace = '';
    /**
     * Required. Name of the GKE service.
     *
     * Generated from protobuf field <code>string service = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $service = '';
    /**
     * Optional. The relative path on the GKE service the events should be sent to.
     * The value must conform to the definition of a URI path segment (section 3.3
     * of RFC2396). Examples: "/route", "route", "route/subroute".
     *
     * Generated from protobuf field <code>string path = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $path = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $cluster
     *           Required. The name of the cluster the GKE service is running in. The cluster must be
     *           running in the same project as the trigger being created.
     *     @type string $location
     *           Required. The name of the Google Compute Engine in which the cluster resides, which
     *           can either be compute zone (for example, us-central1-a) for the zonal
     *           clusters or region (for example, us-central1) for regional clusters.
     *     @type string $namespace
     *           Required. The namespace the GKE service is running in.
     *     @type string $service
     *           Required. Name of the GKE service.
     *     @type string $path
     *           Optional. The relative path on the GKE service the events should be sent to.
     *           The value must conform to the definition of a URI path segment (section 3.3
     *           of RFC2396). Examples: "/route", "route", "route/subroute".
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Eventarc\V1\Trigger::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the cluster the GKE service is running in. The cluster must be
     * running in the same project as the trigger being created.
     *
     * Generated from protobuf field <code>string cluster = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getCluster()
    {
        return $this->cluster;
    }

    /**
     * Required. The name of the cluster the GKE service is running in. The cluster must be
     * running in the same project as the trigger being created.
     *
     * Generated from protobuf field <code>string cluster = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setCluster($var)
    {
        GPBUtil::checkString($var, True);
        $this->cluster = $var;

        return $this;
    }

    /**
     * Required. The name of the Google Compute Engine in which the cluster resides, which
     * can either be compute zone (for example, us-central1-a) for the zonal
     * clusters or region (for example, us-central1) for regional clusters.
     *
     * Generated from protobuf field <code>string location = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * Required. The name of the Google Compute Engine in which the cluster resides, which
     * can either be compute zone (for example, us-central1-a) for the zonal
     * clusters or region (for example, us-central1) for regional clusters.
     *
     * Generated from protobuf field <code>string location = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setLocation($var)
    {
        GPBUtil::checkString($var, True);
        $this->location = $var;

        return $this;
    }

    /**
     * Required. The namespace the GKE service is running in.
     *
     * Generated from protobuf field <code>string namespace = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getNamespace()
    {
        return $this->namespace;
    }

    /**
     * Required. The namespace the GKE service is running in.
     *
     * Generated from protobuf field <code>string namespace = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setNamespace($var)
    {
        GPBUtil::checkString($var, True);
        $this->namespace = $var;

        return $this;
    }

    /**
     * Required. Name of the GKE service.
     *
     * Generated from protobuf field <code>string service = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getService()
    {
        return $this->service;
    }

    /**
     * Required. Name of the GKE service.
     *
     * Generated from protobuf field <code>string service = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setService($var)
    {
        GPBUtil::checkString($var, True);
        $this->service = $var;

        return $this;
    }

    /**
     * Optional. The relative path on the GKE service the events should be sent to.
     * The value must conform to the definition of a URI path segment (section 3.3
     * of RFC2396). Examples: "/route", "route", "route/subroute".
     *
     * Generated from protobuf field <code>string path = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPath()
    {
        return $this->path;
    }

    /**
     * Optional. The relative path on the GKE service the events should be sent to.
     * The value must conform to the definition of a URI path segment (section 3.3
     * of RFC2396). Examples: "/route", "route", "route/subroute".
     *
     * Generated from protobuf field <code>string path = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->path = $var;

        return $this;
    }

}

