<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/gkemulticloud/v1/attached_resources.proto

namespace Google\Cloud\GkeMultiCloud\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An Anthos cluster running on customer own infrastructure.
 *
 * Generated from protobuf message <code>google.cloud.gkemulticloud.v1.AttachedCluster</code>
 */
class AttachedCluster extends \Google\Protobuf\Internal\Message
{
    /**
     * The name of this resource.
     * Cluster names are formatted as
     * `projects/<project-number>/locations/<region>/attachedClusters/<cluster-id>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud Platform resource names.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    private $name = '';
    /**
     * Optional. A human readable description of this cluster.
     * Cannot be longer than 255 UTF-8 encoded bytes.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $description = '';
    /**
     * Required. OpenID Connect (OIDC) configuration for the cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedOidcConfig oidc_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $oidc_config = null;
    /**
     * Required. The platform version for the cluster (e.g. `1.19.0-gke.1000`).
     * You can list all supported versions on a given Google Cloud region by
     * calling
     * [GetAttachedServerConfig][google.cloud.gkemulticloud.v1.AttachedClusters.GetAttachedServerConfig].
     *
     * Generated from protobuf field <code>string platform_version = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $platform_version = '';
    /**
     * Required. The Kubernetes distribution of the underlying attached cluster.
     * Supported values: ["eks", "aks"].
     *
     * Generated from protobuf field <code>string distribution = 16 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $distribution = '';
    /**
     * Output only. The region where this cluster runs.
     * For EKS clusters, this is a AWS region. For AKS clusters,
     * this is an Azure region.
     *
     * Generated from protobuf field <code>string cluster_region = 22 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $cluster_region = '';
    /**
     * Required. Fleet configuration.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.Fleet fleet = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $fleet = null;
    /**
     * Output only. The current state of the cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedCluster.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $state = 0;
    /**
     * Output only. A globally unique identifier for the cluster.
     *
     * Generated from protobuf field <code>string uid = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $uid = '';
    /**
     * Output only. If set, there are currently changes in flight to the cluster.
     *
     * Generated from protobuf field <code>bool reconciling = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $reconciling = false;
    /**
     * Output only. The time at which this cluster was registered.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $create_time = null;
    /**
     * Output only. The time at which this cluster was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $update_time = null;
    /**
     * Allows clients to perform consistent read-modify-writes
     * through optimistic concurrency control.
     * Can be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 11;</code>
     */
    private $etag = '';
    /**
     * Output only. The Kubernetes version of the cluster.
     *
     * Generated from protobuf field <code>string kubernetes_version = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $kubernetes_version = '';
    /**
     * Optional. Annotations on the cluster.
     * This field has the same restrictions as Kubernetes annotations.
     * The total size of all keys and values combined is limited to 256k.
     * Key can have 2 segments: prefix (optional) and name (required),
     * separated by a slash (/).
     * Prefix must be a DNS subdomain.
     * Name must be 63 characters or less, begin and end with alphanumerics,
     * with dashes (-), underscores (_), dots (.), and alphanumerics between.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $annotations;
    /**
     * Output only. Workload Identity settings.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.WorkloadIdentityConfig workload_identity_config = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $workload_identity_config = null;
    /**
     * Optional. Logging configuration for this cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.LoggingConfig logging_config = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $logging_config = null;
    /**
     * Output only. A set of errors found in the cluster.
     *
     * Generated from protobuf field <code>repeated .google.cloud.gkemulticloud.v1.AttachedClusterError errors = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $errors;
    /**
     * Optional. Configuration related to the cluster RBAC settings.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedClustersAuthorization authorization = 21 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $authorization = null;
    /**
     * Optional. Monitoring configuration for this cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.MonitoringConfig monitoring_config = 23 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $monitoring_config = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The name of this resource.
     *           Cluster names are formatted as
     *           `projects/<project-number>/locations/<region>/attachedClusters/<cluster-id>`.
     *           See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     *           for more details on Google Cloud Platform resource names.
     *     @type string $description
     *           Optional. A human readable description of this cluster.
     *           Cannot be longer than 255 UTF-8 encoded bytes.
     *     @type \Google\Cloud\GkeMultiCloud\V1\AttachedOidcConfig $oidc_config
     *           Required. OpenID Connect (OIDC) configuration for the cluster.
     *     @type string $platform_version
     *           Required. The platform version for the cluster (e.g. `1.19.0-gke.1000`).
     *           You can list all supported versions on a given Google Cloud region by
     *           calling
     *           [GetAttachedServerConfig][google.cloud.gkemulticloud.v1.AttachedClusters.GetAttachedServerConfig].
     *     @type string $distribution
     *           Required. The Kubernetes distribution of the underlying attached cluster.
     *           Supported values: ["eks", "aks"].
     *     @type string $cluster_region
     *           Output only. The region where this cluster runs.
     *           For EKS clusters, this is a AWS region. For AKS clusters,
     *           this is an Azure region.
     *     @type \Google\Cloud\GkeMultiCloud\V1\Fleet $fleet
     *           Required. Fleet configuration.
     *     @type int $state
     *           Output only. The current state of the cluster.
     *     @type string $uid
     *           Output only. A globally unique identifier for the cluster.
     *     @type bool $reconciling
     *           Output only. If set, there are currently changes in flight to the cluster.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The time at which this cluster was registered.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The time at which this cluster was last updated.
     *     @type string $etag
     *           Allows clients to perform consistent read-modify-writes
     *           through optimistic concurrency control.
     *           Can be sent on update and delete requests to ensure the
     *           client has an up-to-date value before proceeding.
     *     @type string $kubernetes_version
     *           Output only. The Kubernetes version of the cluster.
     *     @type array|\Google\Protobuf\Internal\MapField $annotations
     *           Optional. Annotations on the cluster.
     *           This field has the same restrictions as Kubernetes annotations.
     *           The total size of all keys and values combined is limited to 256k.
     *           Key can have 2 segments: prefix (optional) and name (required),
     *           separated by a slash (/).
     *           Prefix must be a DNS subdomain.
     *           Name must be 63 characters or less, begin and end with alphanumerics,
     *           with dashes (-), underscores (_), dots (.), and alphanumerics between.
     *     @type \Google\Cloud\GkeMultiCloud\V1\WorkloadIdentityConfig $workload_identity_config
     *           Output only. Workload Identity settings.
     *     @type \Google\Cloud\GkeMultiCloud\V1\LoggingConfig $logging_config
     *           Optional. Logging configuration for this cluster.
     *     @type array<\Google\Cloud\GkeMultiCloud\V1\AttachedClusterError>|\Google\Protobuf\Internal\RepeatedField $errors
     *           Output only. A set of errors found in the cluster.
     *     @type \Google\Cloud\GkeMultiCloud\V1\AttachedClustersAuthorization $authorization
     *           Optional. Configuration related to the cluster RBAC settings.
     *     @type \Google\Cloud\GkeMultiCloud\V1\MonitoringConfig $monitoring_config
     *           Optional. Monitoring configuration for this cluster.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Gkemulticloud\V1\AttachedResources::initOnce();
        parent::__construct($data);
    }

    /**
     * The name of this resource.
     * Cluster names are formatted as
     * `projects/<project-number>/locations/<region>/attachedClusters/<cluster-id>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud Platform resource names.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The name of this resource.
     * Cluster names are formatted as
     * `projects/<project-number>/locations/<region>/attachedClusters/<cluster-id>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud Platform resource names.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. A human readable description of this cluster.
     * Cannot be longer than 255 UTF-8 encoded bytes.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. A human readable description of this cluster.
     * Cannot be longer than 255 UTF-8 encoded bytes.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Required. OpenID Connect (OIDC) configuration for the cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedOidcConfig oidc_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\GkeMultiCloud\V1\AttachedOidcConfig|null
     */
    public function getOidcConfig()
    {
        return $this->oidc_config;
    }

    public function hasOidcConfig()
    {
        return isset($this->oidc_config);
    }

    public function clearOidcConfig()
    {
        unset($this->oidc_config);
    }

    /**
     * Required. OpenID Connect (OIDC) configuration for the cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedOidcConfig oidc_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\GkeMultiCloud\V1\AttachedOidcConfig $var
     * @return $this
     */
    public function setOidcConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeMultiCloud\V1\AttachedOidcConfig::class);
        $this->oidc_config = $var;

        return $this;
    }

    /**
     * Required. The platform version for the cluster (e.g. `1.19.0-gke.1000`).
     * You can list all supported versions on a given Google Cloud region by
     * calling
     * [GetAttachedServerConfig][google.cloud.gkemulticloud.v1.AttachedClusters.GetAttachedServerConfig].
     *
     * Generated from protobuf field <code>string platform_version = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getPlatformVersion()
    {
        return $this->platform_version;
    }

    /**
     * Required. The platform version for the cluster (e.g. `1.19.0-gke.1000`).
     * You can list all supported versions on a given Google Cloud region by
     * calling
     * [GetAttachedServerConfig][google.cloud.gkemulticloud.v1.AttachedClusters.GetAttachedServerConfig].
     *
     * Generated from protobuf field <code>string platform_version = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setPlatformVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->platform_version = $var;

        return $this;
    }

    /**
     * Required. The Kubernetes distribution of the underlying attached cluster.
     * Supported values: ["eks", "aks"].
     *
     * Generated from protobuf field <code>string distribution = 16 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDistribution()
    {
        return $this->distribution;
    }

    /**
     * Required. The Kubernetes distribution of the underlying attached cluster.
     * Supported values: ["eks", "aks"].
     *
     * Generated from protobuf field <code>string distribution = 16 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDistribution($var)
    {
        GPBUtil::checkString($var, True);
        $this->distribution = $var;

        return $this;
    }

    /**
     * Output only. The region where this cluster runs.
     * For EKS clusters, this is a AWS region. For AKS clusters,
     * this is an Azure region.
     *
     * Generated from protobuf field <code>string cluster_region = 22 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getClusterRegion()
    {
        return $this->cluster_region;
    }

    /**
     * Output only. The region where this cluster runs.
     * For EKS clusters, this is a AWS region. For AKS clusters,
     * this is an Azure region.
     *
     * Generated from protobuf field <code>string cluster_region = 22 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setClusterRegion($var)
    {
        GPBUtil::checkString($var, True);
        $this->cluster_region = $var;

        return $this;
    }

    /**
     * Required. Fleet configuration.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.Fleet fleet = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\GkeMultiCloud\V1\Fleet|null
     */
    public function getFleet()
    {
        return $this->fleet;
    }

    public function hasFleet()
    {
        return isset($this->fleet);
    }

    public function clearFleet()
    {
        unset($this->fleet);
    }

    /**
     * Required. Fleet configuration.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.Fleet fleet = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\GkeMultiCloud\V1\Fleet $var
     * @return $this
     */
    public function setFleet($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeMultiCloud\V1\Fleet::class);
        $this->fleet = $var;

        return $this;
    }

    /**
     * Output only. The current state of the cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedCluster.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The current state of the cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedCluster.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\GkeMultiCloud\V1\AttachedCluster\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. A globally unique identifier for the cluster.
     *
     * Generated from protobuf field <code>string uid = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * Output only. A globally unique identifier for the cluster.
     *
     * Generated from protobuf field <code>string uid = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

    /**
     * Output only. If set, there are currently changes in flight to the cluster.
     *
     * Generated from protobuf field <code>bool reconciling = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getReconciling()
    {
        return $this->reconciling;
    }

    /**
     * Output only. If set, there are currently changes in flight to the cluster.
     *
     * Generated from protobuf field <code>bool reconciling = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setReconciling($var)
    {
        GPBUtil::checkBool($var);
        $this->reconciling = $var;

        return $this;
    }

    /**
     * Output only. The time at which this cluster was registered.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The time at which this cluster was registered.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The time at which this cluster was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The time at which this cluster was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Allows clients to perform consistent read-modify-writes
     * through optimistic concurrency control.
     * Can be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 11;</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * Allows clients to perform consistent read-modify-writes
     * through optimistic concurrency control.
     * Can be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * Output only. The Kubernetes version of the cluster.
     *
     * Generated from protobuf field <code>string kubernetes_version = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getKubernetesVersion()
    {
        return $this->kubernetes_version;
    }

    /**
     * Output only. The Kubernetes version of the cluster.
     *
     * Generated from protobuf field <code>string kubernetes_version = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setKubernetesVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->kubernetes_version = $var;

        return $this;
    }

    /**
     * Optional. Annotations on the cluster.
     * This field has the same restrictions as Kubernetes annotations.
     * The total size of all keys and values combined is limited to 256k.
     * Key can have 2 segments: prefix (optional) and name (required),
     * separated by a slash (/).
     * Prefix must be a DNS subdomain.
     * Name must be 63 characters or less, begin and end with alphanumerics,
     * with dashes (-), underscores (_), dots (.), and alphanumerics between.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAnnotations()
    {
        return $this->annotations;
    }

    /**
     * Optional. Annotations on the cluster.
     * This field has the same restrictions as Kubernetes annotations.
     * The total size of all keys and values combined is limited to 256k.
     * Key can have 2 segments: prefix (optional) and name (required),
     * separated by a slash (/).
     * Prefix must be a DNS subdomain.
     * Name must be 63 characters or less, begin and end with alphanumerics,
     * with dashes (-), underscores (_), dots (.), and alphanumerics between.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAnnotations($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->annotations = $arr;

        return $this;
    }

    /**
     * Output only. Workload Identity settings.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.WorkloadIdentityConfig workload_identity_config = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\GkeMultiCloud\V1\WorkloadIdentityConfig|null
     */
    public function getWorkloadIdentityConfig()
    {
        return $this->workload_identity_config;
    }

    public function hasWorkloadIdentityConfig()
    {
        return isset($this->workload_identity_config);
    }

    public function clearWorkloadIdentityConfig()
    {
        unset($this->workload_identity_config);
    }

    /**
     * Output only. Workload Identity settings.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.WorkloadIdentityConfig workload_identity_config = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\GkeMultiCloud\V1\WorkloadIdentityConfig $var
     * @return $this
     */
    public function setWorkloadIdentityConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeMultiCloud\V1\WorkloadIdentityConfig::class);
        $this->workload_identity_config = $var;

        return $this;
    }

    /**
     * Optional. Logging configuration for this cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.LoggingConfig logging_config = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\GkeMultiCloud\V1\LoggingConfig|null
     */
    public function getLoggingConfig()
    {
        return $this->logging_config;
    }

    public function hasLoggingConfig()
    {
        return isset($this->logging_config);
    }

    public function clearLoggingConfig()
    {
        unset($this->logging_config);
    }

    /**
     * Optional. Logging configuration for this cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.LoggingConfig logging_config = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\GkeMultiCloud\V1\LoggingConfig $var
     * @return $this
     */
    public function setLoggingConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeMultiCloud\V1\LoggingConfig::class);
        $this->logging_config = $var;

        return $this;
    }

    /**
     * Output only. A set of errors found in the cluster.
     *
     * Generated from protobuf field <code>repeated .google.cloud.gkemulticloud.v1.AttachedClusterError errors = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getErrors()
    {
        return $this->errors;
    }

    /**
     * Output only. A set of errors found in the cluster.
     *
     * Generated from protobuf field <code>repeated .google.cloud.gkemulticloud.v1.AttachedClusterError errors = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\GkeMultiCloud\V1\AttachedClusterError>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setErrors($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\GkeMultiCloud\V1\AttachedClusterError::class);
        $this->errors = $arr;

        return $this;
    }

    /**
     * Optional. Configuration related to the cluster RBAC settings.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedClustersAuthorization authorization = 21 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\GkeMultiCloud\V1\AttachedClustersAuthorization|null
     */
    public function getAuthorization()
    {
        return $this->authorization;
    }

    public function hasAuthorization()
    {
        return isset($this->authorization);
    }

    public function clearAuthorization()
    {
        unset($this->authorization);
    }

    /**
     * Optional. Configuration related to the cluster RBAC settings.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AttachedClustersAuthorization authorization = 21 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\GkeMultiCloud\V1\AttachedClustersAuthorization $var
     * @return $this
     */
    public function setAuthorization($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeMultiCloud\V1\AttachedClustersAuthorization::class);
        $this->authorization = $var;

        return $this;
    }

    /**
     * Optional. Monitoring configuration for this cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.MonitoringConfig monitoring_config = 23 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\GkeMultiCloud\V1\MonitoringConfig|null
     */
    public function getMonitoringConfig()
    {
        return $this->monitoring_config;
    }

    public function hasMonitoringConfig()
    {
        return isset($this->monitoring_config);
    }

    public function clearMonitoringConfig()
    {
        unset($this->monitoring_config);
    }

    /**
     * Optional. Monitoring configuration for this cluster.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.MonitoringConfig monitoring_config = 23 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\GkeMultiCloud\V1\MonitoringConfig $var
     * @return $this
     */
    public function setMonitoringConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeMultiCloud\V1\MonitoringConfig::class);
        $this->monitoring_config = $var;

        return $this;
    }

}

