<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/resourcemanager/v3/tag_holds.proto

namespace Google\Cloud\ResourceManager\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A TagHold represents the use of a TagValue that is not captured by
 * TagBindings. If a TagValue has any TagHolds, deletion will be blocked.
 * This resource is intended to be created in the same cloud location as the
 * `holder`.
 *
 * Generated from protobuf message <code>google.cloud.resourcemanager.v3.TagHold</code>
 */
class TagHold extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name of a TagHold. This is a String of the form:
     * `tagValues/{tag-value-id}/tagHolds/{tag-hold-id}`
     * (e.g. `tagValues/123/tagHolds/456`). This resource name is generated by
     * the server.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $name = '';
    /**
     * Required. The name of the resource where the TagValue is being used. Must
     * be less than 200 characters. E.g.
     * `//compute.googleapis.com/compute/projects/myproject/regions/us-east-1/instanceGroupManagers/instance-group`
     *
     * Generated from protobuf field <code>string holder = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $holder = '';
    /**
     * Optional. An optional string representing the origin of this request. This
     * field should include human-understandable information to distinguish
     * origins from each other. Must be less than 200 characters. E.g.
     * `migs-35678234`
     *
     * Generated from protobuf field <code>string origin = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $origin = '';
    /**
     * Optional. A URL where an end user can learn more about removing this hold.
     * E.g.
     * `https://cloud.google.com/resource-manager/docs/tags/tags-creating-and-managing`
     *
     * Generated from protobuf field <code>string help_link = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $help_link = '';
    /**
     * Output only. The time this TagHold was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $create_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The resource name of a TagHold. This is a String of the form:
     *           `tagValues/{tag-value-id}/tagHolds/{tag-hold-id}`
     *           (e.g. `tagValues/123/tagHolds/456`). This resource name is generated by
     *           the server.
     *     @type string $holder
     *           Required. The name of the resource where the TagValue is being used. Must
     *           be less than 200 characters. E.g.
     *           `//compute.googleapis.com/compute/projects/myproject/regions/us-east-1/instanceGroupManagers/instance-group`
     *     @type string $origin
     *           Optional. An optional string representing the origin of this request. This
     *           field should include human-understandable information to distinguish
     *           origins from each other. Must be less than 200 characters. E.g.
     *           `migs-35678234`
     *     @type string $help_link
     *           Optional. A URL where an end user can learn more about removing this hold.
     *           E.g.
     *           `https://cloud.google.com/resource-manager/docs/tags/tags-creating-and-managing`
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The time this TagHold was created.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Resourcemanager\V3\TagHolds::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The resource name of a TagHold. This is a String of the form:
     * `tagValues/{tag-value-id}/tagHolds/{tag-hold-id}`
     * (e.g. `tagValues/123/tagHolds/456`). This resource name is generated by
     * the server.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name of a TagHold. This is a String of the form:
     * `tagValues/{tag-value-id}/tagHolds/{tag-hold-id}`
     * (e.g. `tagValues/123/tagHolds/456`). This resource name is generated by
     * the server.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. The name of the resource where the TagValue is being used. Must
     * be less than 200 characters. E.g.
     * `//compute.googleapis.com/compute/projects/myproject/regions/us-east-1/instanceGroupManagers/instance-group`
     *
     * Generated from protobuf field <code>string holder = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getHolder()
    {
        return $this->holder;
    }

    /**
     * Required. The name of the resource where the TagValue is being used. Must
     * be less than 200 characters. E.g.
     * `//compute.googleapis.com/compute/projects/myproject/regions/us-east-1/instanceGroupManagers/instance-group`
     *
     * Generated from protobuf field <code>string holder = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setHolder($var)
    {
        GPBUtil::checkString($var, True);
        $this->holder = $var;

        return $this;
    }

    /**
     * Optional. An optional string representing the origin of this request. This
     * field should include human-understandable information to distinguish
     * origins from each other. Must be less than 200 characters. E.g.
     * `migs-35678234`
     *
     * Generated from protobuf field <code>string origin = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getOrigin()
    {
        return $this->origin;
    }

    /**
     * Optional. An optional string representing the origin of this request. This
     * field should include human-understandable information to distinguish
     * origins from each other. Must be less than 200 characters. E.g.
     * `migs-35678234`
     *
     * Generated from protobuf field <code>string origin = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setOrigin($var)
    {
        GPBUtil::checkString($var, True);
        $this->origin = $var;

        return $this;
    }

    /**
     * Optional. A URL where an end user can learn more about removing this hold.
     * E.g.
     * `https://cloud.google.com/resource-manager/docs/tags/tags-creating-and-managing`
     *
     * Generated from protobuf field <code>string help_link = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getHelpLink()
    {
        return $this->help_link;
    }

    /**
     * Optional. A URL where an end user can learn more about removing this hold.
     * E.g.
     * `https://cloud.google.com/resource-manager/docs/tags/tags-creating-and-managing`
     *
     * Generated from protobuf field <code>string help_link = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setHelpLink($var)
    {
        GPBUtil::checkString($var, True);
        $this->help_link = $var;

        return $this;
    }

    /**
     * Output only. The time this TagHold was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The time this TagHold was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

}

