<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/retail/v2/import_config.proto

namespace Google\Cloud\Retail\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Google Cloud Storage location for input content.
 *
 * Generated from protobuf message <code>google.cloud.retail.v2.GcsSource</code>
 */
class GcsSource extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Google Cloud Storage URIs to input files. URI can be up to
     * 2000 characters long. URIs can match the full object path (for example,
     * `gs://bucket/directory/object.json`) or a pattern matching one or more
     * files, such as `gs://bucket/directory/&#42;.json`. A request can
     * contain at most 100 files, and each file can be up to 2 GB. See
     * [Importing product
     * information](https://cloud.google.com/retail/recommendations-ai/docs/upload-catalog)
     * for the expected file format and setup instructions.
     *
     * Generated from protobuf field <code>repeated string input_uris = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $input_uris;
    /**
     * The schema to use when parsing the data from the source.
     * Supported values for product imports:
     * * `product` (default): One JSON [Product][google.cloud.retail.v2.Product]
     * per line. Each product must
     *   have a valid [Product.id][google.cloud.retail.v2.Product.id].
     * * `product_merchant_center`: See [Importing catalog data from Merchant
     *   Center](https://cloud.google.com/retail/recommendations-ai/docs/upload-catalog#mc).
     * Supported values for user events imports:
     * * `user_event` (default): One JSON
     * [UserEvent][google.cloud.retail.v2.UserEvent] per line.
     * * `user_event_ga360`: Using
     *   https://support.google.com/analytics/answer/3437719.
     * Supported values for control imports:
     * * `control` (default): One JSON [Control][google.cloud.retail.v2.Control]
     * per line.
     * Supported values for catalog attribute imports:
     * * `catalog_attribute` (default): One CSV
     * [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] per line.
     *
     * Generated from protobuf field <code>string data_schema = 2;</code>
     */
    private $data_schema = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $input_uris
     *           Required. Google Cloud Storage URIs to input files. URI can be up to
     *           2000 characters long. URIs can match the full object path (for example,
     *           `gs://bucket/directory/object.json`) or a pattern matching one or more
     *           files, such as `gs://bucket/directory/&#42;.json`. A request can
     *           contain at most 100 files, and each file can be up to 2 GB. See
     *           [Importing product
     *           information](https://cloud.google.com/retail/recommendations-ai/docs/upload-catalog)
     *           for the expected file format and setup instructions.
     *     @type string $data_schema
     *           The schema to use when parsing the data from the source.
     *           Supported values for product imports:
     *           * `product` (default): One JSON [Product][google.cloud.retail.v2.Product]
     *           per line. Each product must
     *             have a valid [Product.id][google.cloud.retail.v2.Product.id].
     *           * `product_merchant_center`: See [Importing catalog data from Merchant
     *             Center](https://cloud.google.com/retail/recommendations-ai/docs/upload-catalog#mc).
     *           Supported values for user events imports:
     *           * `user_event` (default): One JSON
     *           [UserEvent][google.cloud.retail.v2.UserEvent] per line.
     *           * `user_event_ga360`: Using
     *             https://support.google.com/analytics/answer/3437719.
     *           Supported values for control imports:
     *           * `control` (default): One JSON [Control][google.cloud.retail.v2.Control]
     *           per line.
     *           Supported values for catalog attribute imports:
     *           * `catalog_attribute` (default): One CSV
     *           [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] per line.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Retail\V2\ImportConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Google Cloud Storage URIs to input files. URI can be up to
     * 2000 characters long. URIs can match the full object path (for example,
     * `gs://bucket/directory/object.json`) or a pattern matching one or more
     * files, such as `gs://bucket/directory/&#42;.json`. A request can
     * contain at most 100 files, and each file can be up to 2 GB. See
     * [Importing product
     * information](https://cloud.google.com/retail/recommendations-ai/docs/upload-catalog)
     * for the expected file format and setup instructions.
     *
     * Generated from protobuf field <code>repeated string input_uris = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInputUris()
    {
        return $this->input_uris;
    }

    /**
     * Required. Google Cloud Storage URIs to input files. URI can be up to
     * 2000 characters long. URIs can match the full object path (for example,
     * `gs://bucket/directory/object.json`) or a pattern matching one or more
     * files, such as `gs://bucket/directory/&#42;.json`. A request can
     * contain at most 100 files, and each file can be up to 2 GB. See
     * [Importing product
     * information](https://cloud.google.com/retail/recommendations-ai/docs/upload-catalog)
     * for the expected file format and setup instructions.
     *
     * Generated from protobuf field <code>repeated string input_uris = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInputUris($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->input_uris = $arr;

        return $this;
    }

    /**
     * The schema to use when parsing the data from the source.
     * Supported values for product imports:
     * * `product` (default): One JSON [Product][google.cloud.retail.v2.Product]
     * per line. Each product must
     *   have a valid [Product.id][google.cloud.retail.v2.Product.id].
     * * `product_merchant_center`: See [Importing catalog data from Merchant
     *   Center](https://cloud.google.com/retail/recommendations-ai/docs/upload-catalog#mc).
     * Supported values for user events imports:
     * * `user_event` (default): One JSON
     * [UserEvent][google.cloud.retail.v2.UserEvent] per line.
     * * `user_event_ga360`: Using
     *   https://support.google.com/analytics/answer/3437719.
     * Supported values for control imports:
     * * `control` (default): One JSON [Control][google.cloud.retail.v2.Control]
     * per line.
     * Supported values for catalog attribute imports:
     * * `catalog_attribute` (default): One CSV
     * [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] per line.
     *
     * Generated from protobuf field <code>string data_schema = 2;</code>
     * @return string
     */
    public function getDataSchema()
    {
        return $this->data_schema;
    }

    /**
     * The schema to use when parsing the data from the source.
     * Supported values for product imports:
     * * `product` (default): One JSON [Product][google.cloud.retail.v2.Product]
     * per line. Each product must
     *   have a valid [Product.id][google.cloud.retail.v2.Product.id].
     * * `product_merchant_center`: See [Importing catalog data from Merchant
     *   Center](https://cloud.google.com/retail/recommendations-ai/docs/upload-catalog#mc).
     * Supported values for user events imports:
     * * `user_event` (default): One JSON
     * [UserEvent][google.cloud.retail.v2.UserEvent] per line.
     * * `user_event_ga360`: Using
     *   https://support.google.com/analytics/answer/3437719.
     * Supported values for control imports:
     * * `control` (default): One JSON [Control][google.cloud.retail.v2.Control]
     * per line.
     * Supported values for catalog attribute imports:
     * * `catalog_attribute` (default): One CSV
     * [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] per line.
     *
     * Generated from protobuf field <code>string data_schema = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDataSchema($var)
    {
        GPBUtil::checkString($var, True);
        $this->data_schema = $var;

        return $this;
    }

}

