<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/retail/v2/common.proto

namespace Google\Cloud\Retail\V2\Rule;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * * Rule Condition:
 *   - No
 *   [Condition.query_terms][google.cloud.retail.v2.Condition.query_terms]
 *   provided is a global match.
 *   - 1 or more
 *   [Condition.query_terms][google.cloud.retail.v2.Condition.query_terms]
 *   provided are combined with OR operator.
 * * Action Input: The request query and filter that are applied to the
 * retrieved products, in addition to any filters already provided with the
 * SearchRequest. The AND operator is used to combine the query's existing
 * filters with the filter rule(s). NOTE: May result in 0 results when
 * filters conflict.
 * * Action Result: Filters the returned objects to be ONLY those that passed
 * the filter.
 *
 * Generated from protobuf message <code>google.cloud.retail.v2.Rule.FilterAction</code>
 */
class FilterAction extends \Google\Protobuf\Internal\Message
{
    /**
     * A filter to apply on the matching condition results. Supported features:
     * * [filter][google.cloud.retail.v2.Rule.FilterAction.filter] must be set.
     * * Filter syntax is identical to
     * [SearchRequest.filter][google.cloud.retail.v2.SearchRequest.filter]. See
     * more
     *   details at the Retail Search
     *   [user guide](https://cloud.google.com/retail/search/docs/filter-and-order#filter).
     * * To filter products with product ID "product_1" or "product_2", and
     * color
     *   "Red" or "Blue":<br>
     *   *(id: ANY("product_1", "product_2"))<br>*
     *   *AND<br>*
     *   *(colorFamilies: ANY("Red", "Blue"))<br>*
     *
     * Generated from protobuf field <code>string filter = 1;</code>
     */
    private $filter = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $filter
     *           A filter to apply on the matching condition results. Supported features:
     *           * [filter][google.cloud.retail.v2.Rule.FilterAction.filter] must be set.
     *           * Filter syntax is identical to
     *           [SearchRequest.filter][google.cloud.retail.v2.SearchRequest.filter]. See
     *           more
     *             details at the Retail Search
     *             [user guide](https://cloud.google.com/retail/search/docs/filter-and-order#filter).
     *           * To filter products with product ID "product_1" or "product_2", and
     *           color
     *             "Red" or "Blue":<br>
     *             *(id: ANY("product_1", "product_2"))<br>*
     *             *AND<br>*
     *             *(colorFamilies: ANY("Red", "Blue"))<br>*
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Retail\V2\Common::initOnce();
        parent::__construct($data);
    }

    /**
     * A filter to apply on the matching condition results. Supported features:
     * * [filter][google.cloud.retail.v2.Rule.FilterAction.filter] must be set.
     * * Filter syntax is identical to
     * [SearchRequest.filter][google.cloud.retail.v2.SearchRequest.filter]. See
     * more
     *   details at the Retail Search
     *   [user guide](https://cloud.google.com/retail/search/docs/filter-and-order#filter).
     * * To filter products with product ID "product_1" or "product_2", and
     * color
     *   "Red" or "Blue":<br>
     *   *(id: ANY("product_1", "product_2"))<br>*
     *   *AND<br>*
     *   *(colorFamilies: ANY("Red", "Blue"))<br>*
     *
     * Generated from protobuf field <code>string filter = 1;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * A filter to apply on the matching condition results. Supported features:
     * * [filter][google.cloud.retail.v2.Rule.FilterAction.filter] must be set.
     * * Filter syntax is identical to
     * [SearchRequest.filter][google.cloud.retail.v2.SearchRequest.filter]. See
     * more
     *   details at the Retail Search
     *   [user guide](https://cloud.google.com/retail/search/docs/filter-and-order#filter).
     * * To filter products with product ID "product_1" or "product_2", and
     * color
     *   "Red" or "Blue":<br>
     *   *(id: ANY("product_1", "product_2"))<br>*
     *   *AND<br>*
     *   *(colorFamilies: ANY("Red", "Blue"))<br>*
     *
     * Generated from protobuf field <code>string filter = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}


