<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/securitycenter/v1/indicator.proto

namespace Google\Cloud\SecurityCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents what's commonly known as an _indicator of compromise_ (IoC) in
 * computer forensics. This is an artifact observed on a network or in an
 * operating system that, with high confidence, indicates a computer intrusion.
 * For more information, see [Indicator of
 * compromise](https://en.wikipedia.org/wiki/Indicator_of_compromise).
 *
 * Generated from protobuf message <code>google.cloud.securitycenter.v1.Indicator</code>
 */
class Indicator extends \Google\Protobuf\Internal\Message
{
    /**
     * The list of IP addresses that are associated with the finding.
     *
     * Generated from protobuf field <code>repeated string ip_addresses = 1;</code>
     */
    private $ip_addresses;
    /**
     * List of domains associated to the Finding.
     *
     * Generated from protobuf field <code>repeated string domains = 2;</code>
     */
    private $domains;
    /**
     * The list of matched signatures indicating that the given
     * process is present in the environment.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Indicator.ProcessSignature signatures = 3;</code>
     */
    private $signatures;
    /**
     * The list of URIs associated to the Findings.
     *
     * Generated from protobuf field <code>repeated string uris = 4;</code>
     */
    private $uris;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $ip_addresses
     *           The list of IP addresses that are associated with the finding.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $domains
     *           List of domains associated to the Finding.
     *     @type array<\Google\Cloud\SecurityCenter\V1\Indicator\ProcessSignature>|\Google\Protobuf\Internal\RepeatedField $signatures
     *           The list of matched signatures indicating that the given
     *           process is present in the environment.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $uris
     *           The list of URIs associated to the Findings.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Securitycenter\V1\Indicator::initOnce();
        parent::__construct($data);
    }

    /**
     * The list of IP addresses that are associated with the finding.
     *
     * Generated from protobuf field <code>repeated string ip_addresses = 1;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getIpAddresses()
    {
        return $this->ip_addresses;
    }

    /**
     * The list of IP addresses that are associated with the finding.
     *
     * Generated from protobuf field <code>repeated string ip_addresses = 1;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setIpAddresses($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->ip_addresses = $arr;

        return $this;
    }

    /**
     * List of domains associated to the Finding.
     *
     * Generated from protobuf field <code>repeated string domains = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getDomains()
    {
        return $this->domains;
    }

    /**
     * List of domains associated to the Finding.
     *
     * Generated from protobuf field <code>repeated string domains = 2;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setDomains($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->domains = $arr;

        return $this;
    }

    /**
     * The list of matched signatures indicating that the given
     * process is present in the environment.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Indicator.ProcessSignature signatures = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSignatures()
    {
        return $this->signatures;
    }

    /**
     * The list of matched signatures indicating that the given
     * process is present in the environment.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Indicator.ProcessSignature signatures = 3;</code>
     * @param array<\Google\Cloud\SecurityCenter\V1\Indicator\ProcessSignature>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSignatures($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\SecurityCenter\V1\Indicator\ProcessSignature::class);
        $this->signatures = $arr;

        return $this;
    }

    /**
     * The list of URIs associated to the Findings.
     *
     * Generated from protobuf field <code>repeated string uris = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getUris()
    {
        return $this->uris;
    }

    /**
     * The list of URIs associated to the Findings.
     *
     * Generated from protobuf field <code>repeated string uris = 4;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setUris($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->uris = $arr;

        return $this;
    }

}

