<?php
/**
 * Copyright 2016 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

namespace Google\Cloud\Spanner;

/**
 * Contract for various Spanner values.
 * Note: This interface may become internal in the next major version change
 */
interface ValueInterface
{
    /**
     * @return int|string
     */
    public function type();

    /**
     * @return mixed
     */
    public function get();

    /**
     * @return string
     */
    public function formatAsString();

    /**
     * @return string
     */
    public function __toString();
}
