<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/speech/v2/cloud_speech.proto

namespace Google\Cloud\Speech\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the
 * [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] method.
 *
 * Generated from protobuf message <code>google.cloud.speech.v2.ListRecognizersRequest</code>
 */
class ListRecognizersRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The project and location of Recognizers to list. The expected
     * format is `projects/{project}/locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * The maximum number of Recognizers to return. The service may return fewer
     * than this value. If unspecified, at most 5 Recognizers will be returned.
     * The maximum value is 100; values above 100 will be coerced to 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    private $page_size = 0;
    /**
     * A page token, received from a previous
     * [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    private $page_token = '';
    /**
     * Whether, or not, to show resources that have been deleted.
     *
     * Generated from protobuf field <code>bool show_deleted = 4;</code>
     */
    private $show_deleted = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The project and location of Recognizers to list. The expected
     *           format is `projects/{project}/locations/{location}`.
     *     @type int $page_size
     *           The maximum number of Recognizers to return. The service may return fewer
     *           than this value. If unspecified, at most 5 Recognizers will be returned.
     *           The maximum value is 100; values above 100 will be coerced to 100.
     *     @type string $page_token
     *           A page token, received from a previous
     *           [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to
     *           [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] must match
     *           the call that provided the page token.
     *     @type bool $show_deleted
     *           Whether, or not, to show resources that have been deleted.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Speech\V2\CloudSpeech::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The project and location of Recognizers to list. The expected
     * format is `projects/{project}/locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The project and location of Recognizers to list. The expected
     * format is `projects/{project}/locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The maximum number of Recognizers to return. The service may return fewer
     * than this value. If unspecified, at most 5 Recognizers will be returned.
     * The maximum value is 100; values above 100 will be coerced to 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of Recognizers to return. The service may return fewer
     * than this value. If unspecified, at most 5 Recognizers will be returned.
     * The maximum value is 100; values above 100 will be coerced to 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token, received from a previous
     * [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token, received from a previous
     * [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ListRecognizers][google.cloud.speech.v2.Speech.ListRecognizers] must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Whether, or not, to show resources that have been deleted.
     *
     * Generated from protobuf field <code>bool show_deleted = 4;</code>
     * @return bool
     */
    public function getShowDeleted()
    {
        return $this->show_deleted;
    }

    /**
     * Whether, or not, to show resources that have been deleted.
     *
     * Generated from protobuf field <code>bool show_deleted = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setShowDeleted($var)
    {
        GPBUtil::checkBool($var);
        $this->show_deleted = $var;

        return $this;
    }

}

