<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/storageinsights/v1/storageinsights.proto

namespace Google\Cloud\StorageInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message describing ReportConfig object. ReportConfig is the configuration to
 * generate reports.
 * Next ID: 12
 *
 * Generated from protobuf message <code>google.cloud.storageinsights.v1.ReportConfig</code>
 */
class ReportConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * name of resource. It will be of form
     * projects/<project>/locations/<location>/reportConfigs/<report-config-id>.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Output only. [Output only] Create time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. [Output only] Update time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * The frequency of report generation.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.FrequencyOptions frequency_options = 5;</code>
     */
    protected $frequency_options = null;
    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 10;</code>
     */
    private $labels;
    /**
     * User provided display name which can be empty and limited to 256 characters
     * that is editable.
     *
     * Generated from protobuf field <code>string display_name = 11;</code>
     */
    protected $display_name = '';
    protected $report_format;
    protected $report_kind;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           name of resource. It will be of form
     *           projects/<project>/locations/<location>/reportConfigs/<report-config-id>.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. [Output only] Create time stamp
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. [Output only] Update time stamp
     *     @type \Google\Cloud\StorageInsights\V1\FrequencyOptions $frequency_options
     *           The frequency of report generation.
     *     @type \Google\Cloud\StorageInsights\V1\CSVOptions $csv_options
     *           Options for CSV formatted reports.
     *     @type \Google\Cloud\StorageInsights\V1\ParquetOptions $parquet_options
     *           Options for Parquet formatted reports.
     *     @type \Google\Cloud\StorageInsights\V1\ObjectMetadataReportOptions $object_metadata_report_options
     *           Report for exporting object metadata.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels as key value pairs
     *     @type string $display_name
     *           User provided display name which can be empty and limited to 256 characters
     *           that is editable.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Storageinsights\V1\Storageinsights::initOnce();
        parent::__construct($data);
    }

    /**
     * name of resource. It will be of form
     * projects/<project>/locations/<location>/reportConfigs/<report-config-id>.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * name of resource. It will be of form
     * projects/<project>/locations/<location>/reportConfigs/<report-config-id>.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Create time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. [Output only] Create time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Update time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. [Output only] Update time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * The frequency of report generation.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.FrequencyOptions frequency_options = 5;</code>
     * @return \Google\Cloud\StorageInsights\V1\FrequencyOptions|null
     */
    public function getFrequencyOptions()
    {
        return $this->frequency_options;
    }

    public function hasFrequencyOptions()
    {
        return isset($this->frequency_options);
    }

    public function clearFrequencyOptions()
    {
        unset($this->frequency_options);
    }

    /**
     * The frequency of report generation.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.FrequencyOptions frequency_options = 5;</code>
     * @param \Google\Cloud\StorageInsights\V1\FrequencyOptions $var
     * @return $this
     */
    public function setFrequencyOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\StorageInsights\V1\FrequencyOptions::class);
        $this->frequency_options = $var;

        return $this;
    }

    /**
     * Options for CSV formatted reports.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.CSVOptions csv_options = 6;</code>
     * @return \Google\Cloud\StorageInsights\V1\CSVOptions|null
     */
    public function getCsvOptions()
    {
        return $this->readOneof(6);
    }

    public function hasCsvOptions()
    {
        return $this->hasOneof(6);
    }

    /**
     * Options for CSV formatted reports.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.CSVOptions csv_options = 6;</code>
     * @param \Google\Cloud\StorageInsights\V1\CSVOptions $var
     * @return $this
     */
    public function setCsvOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\StorageInsights\V1\CSVOptions::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Options for Parquet formatted reports.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.ParquetOptions parquet_options = 7;</code>
     * @return \Google\Cloud\StorageInsights\V1\ParquetOptions|null
     */
    public function getParquetOptions()
    {
        return $this->readOneof(7);
    }

    public function hasParquetOptions()
    {
        return $this->hasOneof(7);
    }

    /**
     * Options for Parquet formatted reports.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.ParquetOptions parquet_options = 7;</code>
     * @param \Google\Cloud\StorageInsights\V1\ParquetOptions $var
     * @return $this
     */
    public function setParquetOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\StorageInsights\V1\ParquetOptions::class);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     * Report for exporting object metadata.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.ObjectMetadataReportOptions object_metadata_report_options = 8;</code>
     * @return \Google\Cloud\StorageInsights\V1\ObjectMetadataReportOptions|null
     */
    public function getObjectMetadataReportOptions()
    {
        return $this->readOneof(8);
    }

    public function hasObjectMetadataReportOptions()
    {
        return $this->hasOneof(8);
    }

    /**
     * Report for exporting object metadata.
     *
     * Generated from protobuf field <code>.google.cloud.storageinsights.v1.ObjectMetadataReportOptions object_metadata_report_options = 8;</code>
     * @param \Google\Cloud\StorageInsights\V1\ObjectMetadataReportOptions $var
     * @return $this
     */
    public function setObjectMetadataReportOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\StorageInsights\V1\ObjectMetadataReportOptions::class);
        $this->writeOneof(8, $var);

        return $this;
    }

    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 10;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 10;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * User provided display name which can be empty and limited to 256 characters
     * that is editable.
     *
     * Generated from protobuf field <code>string display_name = 11;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * User provided display name which can be empty and limited to 256 characters
     * that is editable.
     *
     * Generated from protobuf field <code>string display_name = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getReportFormat()
    {
        return $this->whichOneof("report_format");
    }

    /**
     * @return string
     */
    public function getReportKind()
    {
        return $this->whichOneof("report_kind");
    }

}

