<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/support/v2/case_service.proto

namespace Google\Cloud\Support\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for the SearchCases endpoint.
 *
 * Generated from protobuf message <code>google.cloud.support.v2.SearchCasesRequest</code>
 */
class SearchCasesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * The fully qualified name of parent resource to search cases under.
     *
     * Generated from protobuf field <code>string parent = 4;</code>
     */
    protected $parent = '';
    /**
     * An expression written in filter language.
     * A query uses the following fields with the operators equals (`=`) and
     * `AND`:
     * - `organization`: An organization name in the form
     * `organizations/<organization_id>`.
     * - `project`: A project name in the form `projects/<project_id>`.
     * - `state`: The accepted values are `OPEN` or `CLOSED`.
     * - `priority`: The accepted values are `P0`, `P1`, `P2`, `P3`, or `P4`. You
     * can specify multiple values for priority using the `OR` operator. For
     * example, `priority=P1 OR priority=P2`.
     * - `creator.email`: The email address of the case creator.
     * - `billingAccount`: A billing account in the form
     * `billingAccounts/<billing_account_id>`
     * You must specify either `organization` or `project`.
     * To search across `displayName`, `description`, and comments, use a global
     * restriction with no keyword or operator. For example, `"my search"`.
     * To search only cases updated after a certain date, use `update_time`
     * restricted with that particular date, time, and timezone in ISO datetime
     * format. For example, `update_time>"2020-01-01T00:00:00-05:00"`.
     * `update_time` only supports the greater than operator (`>`).
     * Examples:
     * - `organization="organizations/123456789"`
     * - `project="projects/my-project-id"`
     * - `project="projects/123456789"`
     * - `billing_account="billingAccounts/123456-A0B0C0-CUZ789"`
     * - `organization="organizations/123456789" AND state=CLOSED`
     * - `project="projects/my-project-id" AND creator.email="tester&#64;example.com"`
     * - `project="projects/my-project-id" AND (priority=P0 OR priority=P1)`
     *
     * Generated from protobuf field <code>string query = 1;</code>
     */
    protected $query = '';
    /**
     * The maximum number of cases fetched with each request. The default page
     * size is 10.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * A token identifying the page of results to return. If unspecified, the
     * first page is retrieved.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           The fully qualified name of parent resource to search cases under.
     *     @type string $query
     *           An expression written in filter language.
     *           A query uses the following fields with the operators equals (`=`) and
     *           `AND`:
     *           - `organization`: An organization name in the form
     *           `organizations/<organization_id>`.
     *           - `project`: A project name in the form `projects/<project_id>`.
     *           - `state`: The accepted values are `OPEN` or `CLOSED`.
     *           - `priority`: The accepted values are `P0`, `P1`, `P2`, `P3`, or `P4`. You
     *           can specify multiple values for priority using the `OR` operator. For
     *           example, `priority=P1 OR priority=P2`.
     *           - `creator.email`: The email address of the case creator.
     *           - `billingAccount`: A billing account in the form
     *           `billingAccounts/<billing_account_id>`
     *           You must specify either `organization` or `project`.
     *           To search across `displayName`, `description`, and comments, use a global
     *           restriction with no keyword or operator. For example, `"my search"`.
     *           To search only cases updated after a certain date, use `update_time`
     *           restricted with that particular date, time, and timezone in ISO datetime
     *           format. For example, `update_time>"2020-01-01T00:00:00-05:00"`.
     *           `update_time` only supports the greater than operator (`>`).
     *           Examples:
     *           - `organization="organizations/123456789"`
     *           - `project="projects/my-project-id"`
     *           - `project="projects/123456789"`
     *           - `billing_account="billingAccounts/123456-A0B0C0-CUZ789"`
     *           - `organization="organizations/123456789" AND state=CLOSED`
     *           - `project="projects/my-project-id" AND creator.email="tester&#64;example.com"`
     *           - `project="projects/my-project-id" AND (priority=P0 OR priority=P1)`
     *     @type int $page_size
     *           The maximum number of cases fetched with each request. The default page
     *           size is 10.
     *     @type string $page_token
     *           A token identifying the page of results to return. If unspecified, the
     *           first page is retrieved.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Support\V2\CaseService::initOnce();
        parent::__construct($data);
    }

    /**
     * The fully qualified name of parent resource to search cases under.
     *
     * Generated from protobuf field <code>string parent = 4;</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * The fully qualified name of parent resource to search cases under.
     *
     * Generated from protobuf field <code>string parent = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * An expression written in filter language.
     * A query uses the following fields with the operators equals (`=`) and
     * `AND`:
     * - `organization`: An organization name in the form
     * `organizations/<organization_id>`.
     * - `project`: A project name in the form `projects/<project_id>`.
     * - `state`: The accepted values are `OPEN` or `CLOSED`.
     * - `priority`: The accepted values are `P0`, `P1`, `P2`, `P3`, or `P4`. You
     * can specify multiple values for priority using the `OR` operator. For
     * example, `priority=P1 OR priority=P2`.
     * - `creator.email`: The email address of the case creator.
     * - `billingAccount`: A billing account in the form
     * `billingAccounts/<billing_account_id>`
     * You must specify either `organization` or `project`.
     * To search across `displayName`, `description`, and comments, use a global
     * restriction with no keyword or operator. For example, `"my search"`.
     * To search only cases updated after a certain date, use `update_time`
     * restricted with that particular date, time, and timezone in ISO datetime
     * format. For example, `update_time>"2020-01-01T00:00:00-05:00"`.
     * `update_time` only supports the greater than operator (`>`).
     * Examples:
     * - `organization="organizations/123456789"`
     * - `project="projects/my-project-id"`
     * - `project="projects/123456789"`
     * - `billing_account="billingAccounts/123456-A0B0C0-CUZ789"`
     * - `organization="organizations/123456789" AND state=CLOSED`
     * - `project="projects/my-project-id" AND creator.email="tester&#64;example.com"`
     * - `project="projects/my-project-id" AND (priority=P0 OR priority=P1)`
     *
     * Generated from protobuf field <code>string query = 1;</code>
     * @return string
     */
    public function getQuery()
    {
        return $this->query;
    }

    /**
     * An expression written in filter language.
     * A query uses the following fields with the operators equals (`=`) and
     * `AND`:
     * - `organization`: An organization name in the form
     * `organizations/<organization_id>`.
     * - `project`: A project name in the form `projects/<project_id>`.
     * - `state`: The accepted values are `OPEN` or `CLOSED`.
     * - `priority`: The accepted values are `P0`, `P1`, `P2`, `P3`, or `P4`. You
     * can specify multiple values for priority using the `OR` operator. For
     * example, `priority=P1 OR priority=P2`.
     * - `creator.email`: The email address of the case creator.
     * - `billingAccount`: A billing account in the form
     * `billingAccounts/<billing_account_id>`
     * You must specify either `organization` or `project`.
     * To search across `displayName`, `description`, and comments, use a global
     * restriction with no keyword or operator. For example, `"my search"`.
     * To search only cases updated after a certain date, use `update_time`
     * restricted with that particular date, time, and timezone in ISO datetime
     * format. For example, `update_time>"2020-01-01T00:00:00-05:00"`.
     * `update_time` only supports the greater than operator (`>`).
     * Examples:
     * - `organization="organizations/123456789"`
     * - `project="projects/my-project-id"`
     * - `project="projects/123456789"`
     * - `billing_account="billingAccounts/123456-A0B0C0-CUZ789"`
     * - `organization="organizations/123456789" AND state=CLOSED`
     * - `project="projects/my-project-id" AND creator.email="tester&#64;example.com"`
     * - `project="projects/my-project-id" AND (priority=P0 OR priority=P1)`
     *
     * Generated from protobuf field <code>string query = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setQuery($var)
    {
        GPBUtil::checkString($var, True);
        $this->query = $var;

        return $this;
    }

    /**
     * The maximum number of cases fetched with each request. The default page
     * size is 10.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of cases fetched with each request. The default page
     * size is 10.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A token identifying the page of results to return. If unspecified, the
     * first page is retrieved.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A token identifying the page of results to return. If unspecified, the
     * first page is retrieved.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

