<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/talent/v4/job_service.proto

namespace Google\Cloud\Talent\V4;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to purge a set of jobs.
 *
 * Generated from protobuf message <code>google.cloud.talent.v4.PurgeJobsRequest</code>
 */
class PurgeJobsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the project under which the jobs should be deleted.
     * The format is "projects/{project_id}". For example, "projects/foo".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Required. A filter matching the jobs to be purged.
     * The filter can be one of the following three parent resources.
     * 1. Company. Resource name of the company under which all the jobs should be
     * deleted. The format is
     * "projects/{project_id}/tenants/{tenant_id}/companies/{company_id}". For
     * example, "projects/foo/tenants/bar/companies/baz"
     * 2. Tenant. Resource name of the tenant under which all the jobs should be
     * deleted. The format is "projects/{project_id}/tenants/{tenant_id}". For
     * example, "projects/foo/tenants/bar".
     * 3. Project. Resource name of the project under which all the jobs should be
     * deleted. The format is "projects/{project_id}". For example,
     * "projects/foo/".
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $filter = '';
    /**
     * Actually perform the purge.
     * If `force` is set to false, the method will return a sample of
     * resource names that will be deleted.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     */
    private $force = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the project under which the jobs should be deleted.
     *           The format is "projects/{project_id}". For example, "projects/foo".
     *     @type string $filter
     *           Required. A filter matching the jobs to be purged.
     *           The filter can be one of the following three parent resources.
     *           1. Company. Resource name of the company under which all the jobs should be
     *           deleted. The format is
     *           "projects/{project_id}/tenants/{tenant_id}/companies/{company_id}". For
     *           example, "projects/foo/tenants/bar/companies/baz"
     *           2. Tenant. Resource name of the tenant under which all the jobs should be
     *           deleted. The format is "projects/{project_id}/tenants/{tenant_id}". For
     *           example, "projects/foo/tenants/bar".
     *           3. Project. Resource name of the project under which all the jobs should be
     *           deleted. The format is "projects/{project_id}". For example,
     *           "projects/foo/".
     *     @type bool $force
     *           Actually perform the purge.
     *           If `force` is set to false, the method will return a sample of
     *           resource names that will be deleted.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Talent\V4\JobService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the project under which the jobs should be deleted.
     * The format is "projects/{project_id}". For example, "projects/foo".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the project under which the jobs should be deleted.
     * The format is "projects/{project_id}". For example, "projects/foo".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. A filter matching the jobs to be purged.
     * The filter can be one of the following three parent resources.
     * 1. Company. Resource name of the company under which all the jobs should be
     * deleted. The format is
     * "projects/{project_id}/tenants/{tenant_id}/companies/{company_id}". For
     * example, "projects/foo/tenants/bar/companies/baz"
     * 2. Tenant. Resource name of the tenant under which all the jobs should be
     * deleted. The format is "projects/{project_id}/tenants/{tenant_id}". For
     * example, "projects/foo/tenants/bar".
     * 3. Project. Resource name of the project under which all the jobs should be
     * deleted. The format is "projects/{project_id}". For example,
     * "projects/foo/".
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Required. A filter matching the jobs to be purged.
     * The filter can be one of the following three parent resources.
     * 1. Company. Resource name of the company under which all the jobs should be
     * deleted. The format is
     * "projects/{project_id}/tenants/{tenant_id}/companies/{company_id}". For
     * example, "projects/foo/tenants/bar/companies/baz"
     * 2. Tenant. Resource name of the tenant under which all the jobs should be
     * deleted. The format is "projects/{project_id}/tenants/{tenant_id}". For
     * example, "projects/foo/tenants/bar".
     * 3. Project. Resource name of the project under which all the jobs should be
     * deleted. The format is "projects/{project_id}". For example,
     * "projects/foo/".
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Actually perform the purge.
     * If `force` is set to false, the method will return a sample of
     * resource names that will be deleted.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     * @return bool
     */
    public function getForce()
    {
        return $this->force;
    }

    /**
     * Actually perform the purge.
     * If `force` is set to false, the method will return a sample of
     * resource names that will be deleted.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setForce($var)
    {
        GPBUtil::checkBool($var);
        $this->force = $var;

        return $this;
    }

}

